"use strict";

// MOVE CHAR AND BACKGROUND ###################################################################################################################
// Движение и анимация ходьбы чара **********************************************************************
let moveCharIntrv = null, // Интервал движения чара
walkAnimIntrv = null, // Интервал анимации ходьбы чара
left_map1 = 0, left_map2 = 100;


// Интервал смещения фонов  **************************************************************************************************************
function walkChar() {
    onesHitMove = true;
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;  
    function rafWalkChar() {
        moveCharIntrv = requestAnimationFrame(rafWalkChar); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            } // Move maps data
	        left_map1 -= 0.20 * rotSpeed * k; if (left_map1 <= -100) left_map1 += 200;
	        left_map2 -= 0.20 * rotSpeed * k; if (left_map2 <= -100) left_map2 += 200;        
	        // Move tree and stone MO data
	        elem.left_elem -= 0.40 * rotSpeed * k; 
	        // Чар подошел к дереву
	        if (elem.hpElem > 0 && elem.left_elem <= 0) { 
	            elem.left_elem = 0; 
	            onesHitMove = false; actName = 'hits'; rotSpeed = 0.5;
	            cancelAnimationFrame(moveCharIntrv); cancelAnimationFrame(walkAnimIntrv); moveCharIntrv = null;
	            rightPupil.style.transform = 'translate(0px, 0px)'; leftPupil.style.transform = 'translate(0px, 0px)';
	            // Transform rotate
	            if (toolsName == 'ex' || toolsName == 'pick') {
	                hba_rot = 0; head_rot = 0;
	                r_arm_rot = 0; fr_arm_rot = 0; r_palm_rot = 0;
	                l_arm_rot = 0; fl_arm_rot = 0; l_palm_rot = 0;
	                r_leg_rot = 0; fr_leg_rot = 0; r_foot_rot = 0;
	                l_leg_rot = 0; fl_leg_rot = 0; l_foot_rot = 0;
	            } else if (toolsName == 'saw') {
	                r_arm_rot = -12; fr_arm_rot = 0; r_palm_rot = 25; 
	                l_arm_rot = 22; fl_arm_rot = -35; l_palm_rot = 0; 
	                r_leg_rot = 0; fr_leg_rot = 0; r_foot_rot = 0;
	                l_leg_rot = 0; fl_leg_rot = 0; l_foot_rot = 0;
	            } else if (toolsName == 'perf') {
	                r_arm_rot = 10; fr_arm_rot = -60; r_palm_rot = -28; 
	                l_arm_rot = 15; fl_arm_rot = -65; l_palm_rot = 0; 
	                r_leg_rot = 0; fr_leg_rot = 0; r_foot_rot = 0;
	                l_leg_rot = 0; fl_leg_rot = 0; l_foot_rot = 0;
	            } 
	        } // Transform translateX
	        backgr1.style.transform = 'translateX(' + left_map1 + '%)'; backgr2.style.transform = 'translateX(' + left_map2 + '%)'; 
			elem.allElem.style.transform = 'translateX(' + elem.left_elem + '%)';
	        // Transform rotate
	        hba.style.transform = 'rotate(' + hba_rot + 'deg)'; head.style.transform = 'rotate(' + head_rot + 'deg)';
	        rightArm.style.transform = 'rotate(' + r_arm_rot + 'deg)'; firRightArm.style.transform = 'rotate(' + fr_arm_rot + 'deg)';
	        rightPalm.style.transform = 'rotate(' + r_palm_rot + 'deg)';
	        leftArm.style.transform = 'rotate(' + l_arm_rot + 'deg)'; firLeftArm.style.transform = 'rotate(' + fl_arm_rot + 'deg)';
	        leftPalm.style.transform = 'rotate(' + l_palm_rot + 'deg)';
	        rightLeg.style.transform = 'rotate(' + r_leg_rot + 'deg)'; firRightLeg.style.transform = 'rotate(' + fr_leg_rot + 'deg)';
	        rightFoot.style.transform = 'rotate(' + r_foot_rot + 'deg)';
	        leftLeg.style.transform = 'rotate(' + l_leg_rot + 'deg)'; firLeftLeg.style.transform = 'rotate(' + fl_leg_rot + 'deg)';
	        leftFoot.style.transform = 'rotate(' + l_foot_rot + 'deg)';
	        k = 0;
	        //console.log('walk');
	    }
    } rafWalkChar();
}
    
// Функции анимации ходбы чара *************************************
function moveChar() {
    let moveDir = 1;
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;  
    function rafMoveChar() {
        walkAnimIntrv = requestAnimationFrame(rafMoveChar); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            }
	        if (moveDir == 1) {
	            if (toolsName == 'ex' || toolsName == 'pick') {
	                // Righr arm
	                if (r_arm_rot > -20) r_arm_rot -= rotSpeed * 2 * k; 
	                if (fr_arm_rot > -13) fr_arm_rot -= rotSpeed * 1 * k; 
	                if (r_palm_rot > 0) r_palm_rot -= rotSpeed * 1 * k; 
	                // Left arm
	                if (l_arm_rot > 5) l_arm_rot -= rotSpeed * 0.35 * k; 
	                if (fl_arm_rot > -75) fl_arm_rot -= rotSpeed * 4.1 * k; 
	                if (l_palm_rot > 0) l_palm_rot -= rotSpeed * 1 * k; 
	            } else if (toolsName == 'saw') {
	                // Righr arm
	                if (r_arm_rot > -27) r_arm_rot -= rotSpeed * 0.75 * k; 
	                // Left arm
	                if (fl_arm_rot > -65) fl_arm_rot -= rotSpeed * 1.5 * k; 
	            } else if (toolsName == 'perf') {
	                // Righr arm
	                if (fr_arm_rot > -60) fr_arm_rot -= rotSpeed * 0.5 * k;  
	                // Left arm
	                if (fl_arm_rot > -65) fl_arm_rot -= rotSpeed * 1.25 * k; 
	            } // Righr leg
	            if (r_leg_rot < 20) r_leg_rot += rotSpeed * 3.25 * k; 
	            if (fr_leg_rot > -10) fr_leg_rot -= rotSpeed * 1 * k; 
	            if (r_foot_rot > -10) r_foot_rot -= rotSpeed * 0.5 * k; 
	            // Left leg
	            if (l_leg_rot > -15) l_leg_rot -= rotSpeed * 3.25 * k; 
	            if (fl_leg_rot < 5) fl_leg_rot += rotSpeed * 1.75 * k; 
	            if (l_foot_rot < -10) l_foot_rot += rotSpeed * 1 * k;
	            // Переход на позицию 2
	            if (r_leg_rot >= 20 && l_leg_rot <= 0) {
	                moveDir = 2; 
	            }
	        } else if (moveDir == 2) {
	            if (toolsName == 'ex' || toolsName == 'pick') {
	                // Righr arm
	                if (r_arm_rot < 20) r_arm_rot += rotSpeed * 2 * k; 
	                if (fr_arm_rot > -13) fr_arm_rot -= rotSpeed * 0.65 * k;  
	                if (r_palm_rot > 0) r_palm_rot -= rotSpeed * 1 * k; 
	                // Left arm
	                if (l_arm_rot < 12) l_arm_rot += rotSpeed * 0.35 * k;
	                if (fl_arm_rot < 0) fl_arm_rot += rotSpeed * 3.6 * k;  
	                if (l_palm_rot > 0) l_palm_rot -= rotSpeed * 1 * k; 
	            } else if (toolsName == 'saw') {
	                // Righr arm
	                if (r_arm_rot < -12) r_arm_rot += rotSpeed * 0.75 * k; 
	                // Left arm
	                if (fl_arm_rot < -35) fl_arm_rot += rotSpeed * 1.5 * k; 
	            } else if (toolsName == 'perf') {
	                // Righr arm
	                if (fr_arm_rot < -50) fr_arm_rot += rotSpeed * 0.5 * k;  
	                // Left arm
	                if (fl_arm_rot < -40) fl_arm_rot += rotSpeed * 1.25 * k;  
	            } // Righr leg
	            if (r_leg_rot > -45) r_leg_rot -= rotSpeed * 3.25 * k; 
	            if (fr_leg_rot < 10) fr_leg_rot += rotSpeed * 1 * k; 
	            if (r_foot_rot < 0) r_foot_rot += rotSpeed * 0.5 * k; 
	            // Left leg
	            if (l_leg_rot < 50) l_leg_rot += rotSpeed * 3.25 * k; 
	            if (fl_leg_rot > -30) fl_leg_rot -= rotSpeed * 1.75 * k; 
	            if (l_foot_rot > -30) l_foot_rot -= rotSpeed * 1 * k;
	            // Переход в функцию moveChar()
	            if (r_leg_rot <= -45 && l_leg_rot >= 50) {
	                moveDir = 1; 
	            }
	        } // Transform rotate
	        rightArm.style.transform = 'rotate(' + r_arm_rot + 'deg)'; firRightArm.style.transform = 'rotate(' + fr_arm_rot + 'deg)';
	        rightPalm.style.transform = 'rotate(' + r_palm_rot + 'deg)';
	        leftArm.style.transform = 'rotate(' + l_arm_rot + 'deg)'; firLeftArm.style.transform = 'rotate(' + fl_arm_rot + 'deg)';
	        leftPalm.style.transform = 'rotate(' + l_palm_rot + 'deg)';
	        rightLeg.style.transform = 'rotate(' + r_leg_rot + 'deg)'; firRightLeg.style.transform = 'rotate(' + fr_leg_rot + 'deg)';
	        rightFoot.style.transform = 'rotate(' + r_foot_rot + 'deg)';
	        leftLeg.style.transform = 'rotate(' + l_leg_rot + 'deg)'; firLeftLeg.style.transform = 'rotate(' + fl_leg_rot + 'deg)';
	        leftFoot.style.transform = 'rotate(' + l_foot_rot + 'deg)';
	        k = 0; 
	        //console.log('moveChar');
    	}
    } rafMoveChar();
}

function moveCharStart() {
    rightPupil.style.transform = 'translate(3px, 1px)'; leftPupil.style.transform = 'translate(3px, 1px)';
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;  
    function rafMoveCharStart() {
        walkAnimIntrv = requestAnimationFrame(rafMoveCharStart); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            }
	        if (toolsName == 'ex' || toolsName == 'pick') {
	            // Righr arm
	            if (r_arm_rot < 20) r_arm_rot += rotSpeed * 1 * k; 
	            if (fr_arm_rot > -13) fr_arm_rot -= rotSpeed * 0.65 * k;  
	            if (r_palm_rot > 0) r_palm_rot -= rotSpeed * 1 * k; 
	            // Left arm
	            if (l_arm_rot < 12) l_arm_rot += rotSpeed * 0.6 * k;
	            if (fl_arm_rot > 0) fl_arm_rot -= rotSpeed * 1 * k;  
	            if (l_palm_rot > 0) l_palm_rot -= rotSpeed * 1 * k; 
	        } else if (toolsName == 'perf') {
	            // Righr arm
	            if (fr_arm_rot < -50) fr_arm_rot += rotSpeed * 0.5 * k;  
	            // Left arm
	            if (fl_arm_rot < -40) fl_arm_rot += rotSpeed * 1.25 * k;  
	        } // Hba and head
	        if (hba_rot < 4) hba_rot += rotSpeed * 0.2 * k; 
	        if (head_rot > 0) head_rot -= rotSpeed * 1 * k; 
	        // Righr leg
	        if (r_leg_rot > -45) r_leg_rot -= rotSpeed * 2.25 * k; 
	        if (fr_leg_rot < 10) fr_leg_rot += rotSpeed * 0.5 * k; 
	        if (r_foot_rot < 0) r_foot_rot -= rotSpeed * 1 * k; 
	        // Left leg
	        if (l_leg_rot < 50) l_leg_rot += rotSpeed * 2.5 * k; 
	        if (fl_leg_rot > -30) fl_leg_rot -= rotSpeed * 1.5 * k; 
	        if (l_foot_rot > -30) l_foot_rot -= rotSpeed * 2.25 * k;
	        // Переход в функцию moveChar()
	        if (r_leg_rot <= -45 && l_leg_rot >= 50) {
	            cancelAnimationFrame(walkAnimIntrv); moveChar(); 
	        } // Transform rotate
	        hba.style.transform = 'rotate(' + hba_rot + 'deg)'; head.style.transform = 'rotate(' + head_rot + 'deg)';
	        rightArm.style.transform = 'rotate(' + r_arm_rot + 'deg)'; firRightArm.style.transform = 'rotate(' + fr_arm_rot + 'deg)';
	        rightPalm.style.transform = 'rotate(' + r_palm_rot + 'deg)';
	        leftArm.style.transform = 'rotate(' + l_arm_rot + 'deg)'; firLeftArm.style.transform = 'rotate(' + fl_arm_rot + 'deg)';
	        leftPalm.style.transform = 'rotate(' + l_palm_rot + 'deg)';
	        rightLeg.style.transform = 'rotate(' + r_leg_rot + 'deg)'; firRightLeg.style.transform = 'rotate(' + fr_leg_rot + 'deg)';
	        rightFoot.style.transform = 'rotate(' + r_foot_rot + 'deg)';
	        leftLeg.style.transform = 'rotate(' + l_leg_rot + 'deg)'; firLeftLeg.style.transform = 'rotate(' + fl_leg_rot + 'deg)';
	        leftFoot.style.transform = 'rotate(' + l_foot_rot + 'deg)';
	        k = 0;
	    }
    } rafMoveCharStart();
}





// INITIALIZATION TREES ANS STONES ELEMENTS AND FUNCTIONS #####################################################################################
// Данные по деревьям и камням **************************************************************************
let elem, // Tree or stone
fillTreeFlag = 1, // Флаг цвета деревьев = 1, 2 или 3
creatElemNum = 0, // Номер обьекта в массиве обьктов-параметров для конструктора
shakeIntrv = null, shakeTimer = null, 
deadElemIntrv = null, // Интервал падения дерева
pieceNum = 0, // Number piece
// Обьекты параметров в конструктор
creatTree, creatStone;

// Контсруктор деревьев  
function CreatTrees(obj) {
    this.allElem = obj.allElem; this.topElem = obj.topElem; this.bottomElem = obj.bottomElem; 
    this.piece = obj.piece; this.hpOnePiece = obj.hpOnePiece; this.lvlRes = obj.lvlRes; this.hpElem = obj.hpElem; 
    this.toElem = obj.toElem; this.toTopElem = obj.toTopElem; this.hpPiece = obj.hpPiece; this.quantPiece = obj.quantPiece; 
    this.rarity = obj.rarity; this.numRarRes = obj.numRarRes; this.resPiece = obj.resPiece;  this.expPiece = obj.expPiece;
    this.left_elem = 90; this.fillTree = document.querySelectorAll('.fill-tree'); 
    this.fillTree2 = document.querySelectorAll('.fill-tree2'); this.fillPattern = document.querySelectorAll('.fill-pattern'); 
}
// Контсруктор обьектов камней  
function CreatStones(obj) {
    this.allElem = obj.allElem; this.piece = obj.piece; this.hpElem = obj.hpElem; this.toElem = obj.toElem;
    this.hpPiece = obj.hpPiece; this.lvlRes = obj.lvlRes; this.hpOnePiece = obj.hpOnePiece; this.quantPiece = obj.quantPiece;
    this.rarity = obj.rarity; this.numRarRes = obj.numRarRes; this.resPiece = obj.resPiece; this.expPiece = obj.expPiece; 
    this.left_elem = 90;
}
// Массив обьектов параметров в конструктор CreatTrees
creatTree = [
    { // Tree LVL 1 
        elemMA: document.getElementById('tree1'), allElem: document.getElementById('tree1'), 
        topElem: document.getElementById('top-tree1'), bottomElem: document.getElementById('bottom-tree1'), 
        piece: [document.getElementById('notch1_x5F_1'), document.getElementById('notch1_x5F_2'), document.getElementById('notch1_x5F_3'), 
            document.getElementById('notch1_x5F_4'), document.getElementById('notch1_x5F_5')],
        hpElem: 48, toElem: '1191.5px 932.3px', toTopElem: '1238px 777px', hpOnePiece: 8, resPiece: 1, expPiece: 1, lvlRes: 1, quantPiece: 4,
        hpPiece: [40, 32, 24, 16, 8, 0],         
    }, { 
        elemMA: document.getElementById('tree2'), allElem: document.getElementById('tree2'), 
        topElem: document.getElementById('top-tree2'), bottomElem: document.getElementById('bottom-tree2'), 
        piece: [document.getElementById('notch2_x5F_1'), document.getElementById('notch2_x5F_2'), document.getElementById('notch2_x5F_3'), 
            document.getElementById('notch2_x5F_4'), document.getElementById('notch2_x5F_5'), document.getElementById('notch2_x5F_6')],
        hpElem: 77, toElem: '1188px 932.3px', toTopElem: '1249px 777px', hpOnePiece: 11, resPiece: 2, expPiece: 1, lvlRes: 1, quantPiece: 5,
        hpPiece: [66, 55, 44, 33, 22, 11, 0],         
    }, { 
        elemMA: document.getElementById('tree3'), allElem: document.getElementById('tree3'), 
        topElem: document.getElementById('top-tree3'), bottomElem: document.getElementById('bottom-tree3'), 
        piece: [document.getElementById('notch3_x5F_1'), document.getElementById('notch3_x5F_2'), document.getElementById('notch3_x5F_3'), 
            document.getElementById('notch3_x5F_4'), document.getElementById('notch3_x5F_5'), document.getElementById('notch3_x5F_6'), 
            document.getElementById('notch3_x5F_7'), document.getElementById('notch3_x5F_8'), document.getElementById('notch3_x5F_9')],
        hpElem: 130, toElem: '1191.5px 932.3px', toTopElem: '1262px 777px', hpOnePiece: 13, resPiece: 2, expPiece: 2, lvlRes: 1, quantPiece: 8,
        hpPiece: [117, 104, 91, 78, 65, 52, 39, 26, 13, 0],         
    }, { 
        elemMA: document.getElementById('tree4'), allElem: document.getElementById('tree4'), 
        topElem: document.getElementById('top-tree4'), bottomElem: document.getElementById('bottom-tree4'), 
        piece: [document.getElementById('notch4_x5F_1'), document.getElementById('notch4_x5F_2'), document.getElementById('notch4_x5F_3'), 
            document.getElementById('notch4_x5F_4'), document.getElementById('notch4_x5F_5'), document.getElementById('notch4_x5F_6'), 
            document.getElementById('notch4_x5F_7'), document.getElementById('notch4_x5F_8'), document.getElementById('notch4_x5F_9')],
        hpElem: 180, toElem: '1187.5px 932.3px', toTopElem: '1263px 777px', hpOnePiece: 18, resPiece: 3, expPiece: 2, lvlRes: 1, quantPiece: 8,
        hpPiece: [162, 144, 126, 108, 90, 72, 54, 36, 18, 0],         
    }, { 
        elemMA: document.getElementById('tree5'), allElem: document.getElementById('tree5'), 
        topElem: document.getElementById('top-tree5'), bottomElem: document.getElementById('bottom-tree5'), 
        piece: [document.getElementById('notch5_x5F_1'), document.getElementById('notch5_x5F_2'), document.getElementById('notch5_x5F_3'), 
            document.getElementById('notch5_x5F_4'), document.getElementById('notch5_x5F_5'), document.getElementById('notch5_x5F_6'), 
            document.getElementById('notch5_x5F_7'), document.getElementById('notch5_x5F_8'), document.getElementById('notch5_x5F_9'), 
            document.getElementById('notch5_x5F_10'), document.getElementById('notch5_x5F_11'),document.getElementById('notch5_x5F_12')],
        hpElem: 273, toElem: '1196.1px 932.3px', toTopElem: '1290px 777px', hpOnePiece: 21, resPiece: 3, expPiece: 3, lvlRes: 1, quantPiece: 11,
        hpPiece: [252, 231, 210, 189, 168, 147, 126, 105, 84, 63, 42, 21, 0],         
    }, {  
        elemMA: document.getElementById('tree6'), allElem: document.getElementById('tree6'), 
        topElem: document.getElementById('top-tree6'), bottomElem: document.getElementById('bottom-tree6'), 
        piece: [document.getElementById('notch6_x5F_1'), document.getElementById('notch6_x5F_2'), document.getElementById('notch6_x5F_3'), 
            document.getElementById('notch6_x5F_4'), document.getElementById('notch6_x5F_5'), document.getElementById('notch6_x5F_6'), 
            document.getElementById('notch6_x5F_7'), document.getElementById('notch6_x5F_8'), document.getElementById('notch6_x5F_9'), 
            document.getElementById('notch6_x5F_10'), document.getElementById('notch6_x5F_11'), document.getElementById('notch6_x5F_12'),
            document.getElementById('notch6_x5F_13'), document.getElementById('notch6_x5F_14')],
        hpElem: 405, toElem: '1202.4px 933px', toTopElem: '1316px 777px', hpOnePiece: 27, resPiece: 4, expPiece: 3, lvlRes: 1, quantPiece: 13,
        hpPiece: [378, 351, 324, 297, 270, 243, 216, 189, 162, 135, 108, 81, 54, 27, 0],         
    },  {  
        elemMA: document.getElementById('tree7'), allElem: document.getElementById('tree7'), 
        topElem: document.getElementById('top-tree7'), bottomElem: document.getElementById('bottom-tree7'), 
        piece: [document.getElementById('notch7_x5F_1'), document.getElementById('notch7_x5F_2'), document.getElementById('notch7_x5F_3'), 
            document.getElementById('notch7_x5F_4'), document.getElementById('notch7_x5F_5'), document.getElementById('notch7_x5F_6'), 
            document.getElementById('notch7_x5F_7'), document.getElementById('notch7_x5F_8'), document.getElementById('notch7_x5F_9'), 
            document.getElementById('notch7_x5F_10'), document.getElementById('notch7_x5F_11'), document.getElementById('notch7_x5F_12'),
            document.getElementById('notch7_x5F_13'), document.getElementById('notch7_x5F_14'), document.getElementById('notch7_x5F_15'),
            document.getElementById('notch7_x5F_16'), document.getElementById('notch7_x5F_17'),document.getElementById('notch7_x5F_18')],
        hpElem: 608, toElem: '1201px 927px', toTopElem: '1349px 777px', hpOnePiece: 32, resPiece: 5, expPiece: 4, lvlRes: 1, quantPiece: 17,
        hpPiece: [576, 544, 512, 480, 448, 416, 384, 352, 320, 288, 256, 224, 192, 160, 128, 96, 64, 32, 0],         
    },  {  
        elemMA: document.getElementById('tree8'), allElem: document.getElementById('tree8'), 
        topElem: document.getElementById('top-tree8'), bottomElem: document.getElementById('bottom-tree8'), 
        piece: [document.getElementById('notch8_x5F_1'), document.getElementById('notch8_x5F_2'), document.getElementById('notch8_x5F_3'), 
            document.getElementById('notch8_x5F_4'), document.getElementById('notch8_x5F_5'), document.getElementById('notch8_x5F_6'), 
            document.getElementById('notch8_x5F_7'), document.getElementById('notch8_x5F_8'), document.getElementById('notch8_x5F_9'), 
            document.getElementById('notch8_x5F_10'), document.getElementById('notch8_x5F_11'), document.getElementById('notch8_x5F_12'),
            document.getElementById('notch8_x5F_13'), document.getElementById('notch8_x5F_14'), document.getElementById('notch8_x5F_15'),
            document.getElementById('notch8_x5F_16'), document.getElementById('notch8_x5F_17'),document.getElementById('notch8_x5F_18'), 
            document.getElementById('notch8_x5F_19'), document.getElementById('notch8_x5F_20')],
        hpElem: 924, toElem: '1220px 923px', toTopElem: '1389px 777px', hpOnePiece: 44, resPiece: 7, expPiece: 5, lvlRes: 1, quantPiece: 19,
        hpPiece: [880, 836, 792, 748, 704, 660, 616, 572, 528, 484, 440, 396, 352, 308, 264, 220, 176, 132, 88, 44, 0],         
    },  {  
        elemMA: document.getElementById('tree9'), allElem: document.getElementById('tree9'), 
        topElem: document.getElementById('top-tree9'), bottomElem: document.getElementById('bottom-tree9'), 
        piece: [document.getElementById('notch9_x5F_1'), document.getElementById('notch9_x5F_2'), document.getElementById('notch9_x5F_3'), 
            document.getElementById('notch9_x5F_4'), document.getElementById('notch9_x5F_5'), document.getElementById('notch9_x5F_6'), 
            document.getElementById('notch9_x5F_7'), document.getElementById('notch9_x5F_8'), document.getElementById('notch9_x5F_9'), 
            document.getElementById('notch9_x5F_10'), document.getElementById('notch9_x5F_11'), document.getElementById('notch9_x5F_12'),
            document.getElementById('notch9_x5F_13'), document.getElementById('notch9_x5F_14'), document.getElementById('notch9_x5F_15'),
            document.getElementById('notch9_x5F_16'), document.getElementById('notch9_x5F_17'),document.getElementById('notch9_x5F_18'), 
            document.getElementById('notch9_x5F_19'), document.getElementById('notch9_x5F_20'), document.getElementById('notch9_x5F_21'),
            document.getElementById('notch9_x5F_22')],
        hpElem: 1380, toElem: '1223px 924px', toTopElem: '1440px 777px', hpOnePiece: 60, resPiece: 10, expPiece: 7, lvlRes: 1, quantPiece: 21,
        hpPiece: [1320, 1260, 1200, 1140, 1080, 1020, 960, 900, 840, 780, 720, 660, 600, 540, 480, 420, 360, 300, 240, 180, 120, 60, 0],         
    }, {  
        elemMA: document.getElementById('tree10'), allElem: document.getElementById('tree10'), 
        topElem: document.getElementById('top-tree10'), bottomElem: document.getElementById('bottom-tree10'), 
        piece: [document.getElementById('notch10_x5F_1'), document.getElementById('notch10_x5F_2'), document.getElementById('notch10_x5F_3'),
            document.getElementById('notch10_x5F_4'), document.getElementById('notch10_x5F_5'), document.getElementById('notch10_x5F_6'),
            document.getElementById('notch10_x5F_7'), document.getElementById('notch10_x5F_8'), document.getElementById('notch10_x5F_9'),
            document.getElementById('notch10_x5F_10'), document.getElementById('notch10_x5F_11'),
            document.getElementById('notch10_x5F_12'), document.getElementById('notch10_x5F_13'), 
            document.getElementById('notch10_x5F_14'), document.getElementById('notch10_x5F_15'),
            document.getElementById('notch10_x5F_16'), document.getElementById('notch10_x5F_17'),
            document.getElementById('notch10_x5F_18'), document.getElementById('notch10_x5F_19'), 
            document.getElementById('notch10_x5F_20'), document.getElementById('notch10_x5F_21'),
            document.getElementById('notch10_x5F_22'), document.getElementById('notch10_x5F_23'),
            document.getElementById('notch10_x5F_24')],
        hpElem: 2075, toElem: '1248px 933px', toTopElem: '1490px 777px', hpOnePiece: 83, resPiece: 14, expPiece: 10, lvlRes: 1, quantPiece: 23,
        hpPiece: [1992, 1909, 1826, 1743, 1660, 1577, 1494, 1411, 1328, 1245, 1162, 1079, 996, 913, 830, 747, 664, 581, 498, 415, 332, 249, 166, 83, 0], 
    }, 
    { // Tree LVL 2 
        elemMA: document.getElementById('tree1'), allElem: document.getElementById('tree1'), 
        topElem: document.getElementById('top-tree1'), bottomElem: document.getElementById('bottom-tree1'), 
        piece: [document.getElementById('notch1_x5F_1'), document.getElementById('notch1_x5F_2'), document.getElementById('notch1_x5F_3'), 
            document.getElementById('notch1_x5F_4'), document.getElementById('notch1_x5F_5')],
        hpElem: 960, toElem: '1191.5px 932.3px', toTopElem: '1238px 777px', hpOnePiece: 160, resPiece: 27, expPiece: 20, lvlRes: 2, 
        rarity: 7, numRarRes: 2, quantPiece: 4,
        hpPiece: [800, 640, 480, 320, 160, 0], 
    }, { 
        elemMA: document.getElementById('tree2'), allElem: document.getElementById('tree2'), 
        topElem: document.getElementById('top-tree2'), bottomElem: document.getElementById('bottom-tree2'), 
        piece: [document.getElementById('notch2_x5F_1'), document.getElementById('notch2_x5F_2'), document.getElementById('notch2_x5F_3'), 
            document.getElementById('notch2_x5F_4'), document.getElementById('notch2_x5F_5'), document.getElementById('notch2_x5F_6')],
        hpElem: 1540, toElem: '1188px 932.3px', toTopElem: '1249px 777px', hpOnePiece: 220, resPiece: 37, expPiece: 27, lvlRes: 2, 
        rarity: 9, numRarRes: 2, quantPiece: 5,
        hpPiece: [1320, 1100, 880, 660, 440, 220, 0], 
    }, { 
        elemMA: document.getElementById('tree3'), allElem: document.getElementById('tree3'), 
        topElem: document.getElementById('top-tree3'), bottomElem: document.getElementById('bottom-tree3'), 
        piece: [document.getElementById('notch3_x5F_1'), document.getElementById('notch3_x5F_2'), document.getElementById('notch3_x5F_3'), 
            document.getElementById('notch3_x5F_4'), document.getElementById('notch3_x5F_5'), document.getElementById('notch3_x5F_6'), 
            document.getElementById('notch3_x5F_7'), document.getElementById('notch3_x5F_8'), document.getElementById('notch3_x5F_9')],
        hpElem: 2600, toElem: '1191.5px 932.3px', toTopElem: '1262px 777px', hpOnePiece: 260, resPiece: 43, expPiece: 32, lvlRes: 2, 
        rarity: 7, numRarRes: 3, quantPiece: 8,
        hpPiece: [2340, 2080, 1820, 1560, 1300, 1040, 780, 520, 260, 0], 
    }, { 
        elemMA: document.getElementById('tree4'), allElem: document.getElementById('tree4'), 
        topElem: document.getElementById('top-tree4'), bottomElem: document.getElementById('bottom-tree4'), 
        piece: [document.getElementById('notch4_x5F_1'), document.getElementById('notch4_x5F_2'), document.getElementById('notch4_x5F_3'), 
            document.getElementById('notch4_x5F_4'), document.getElementById('notch4_x5F_5'), document.getElementById('notch4_x5F_6'), 
            document.getElementById('notch4_x5F_7'), document.getElementById('notch4_x5F_8'), document.getElementById('notch4_x5F_9')],
        hpElem: 3600, toElem: '1187.5px 932.3px', toTopElem: '1263px 777px', hpOnePiece: 360, resPiece: 60, expPiece: 45, lvlRes: 2, 
        rarity: 10, numRarRes: 3, quantPiece: 8,
        hpPiece: [3240, 2880, 2520, 2160, 1800, 1440, 1080, 720, 360, 0], 
    }, { 
        elemMA: document.getElementById('tree5'), allElem: document.getElementById('tree5'), 
        topElem: document.getElementById('top-tree5'), bottomElem: document.getElementById('bottom-tree5'), 
        piece: [document.getElementById('notch5_x5F_1'), document.getElementById('notch5_x5F_2'), document.getElementById('notch5_x5F_3'), 
            document.getElementById('notch5_x5F_4'), document.getElementById('notch5_x5F_5'), document.getElementById('notch5_x5F_6'), 
            document.getElementById('notch5_x5F_7'), document.getElementById('notch5_x5F_8'), document.getElementById('notch5_x5F_9'), 
            document.getElementById('notch5_x5F_10'), document.getElementById('notch5_x5F_11'),document.getElementById('notch5_x5F_12')],
        hpElem: 5460, toElem: '1196.1px 932.3px', toTopElem: '1290px 777px', hpOnePiece: 420, resPiece: 70, expPiece: 52, lvlRes: 2, 
        rarity: 9, numRarRes: 4, quantPiece: 11,
        hpPiece: [5040, 4620, 4200, 3780, 3360, 2940, 2520, 2100, 1680, 1260, 840, 420, 0], 
    }, {  
        elemMA: document.getElementById('tree6'), allElem: document.getElementById('tree6'), 
        topElem: document.getElementById('top-tree6'), bottomElem: document.getElementById('bottom-tree6'), 
        piece: [document.getElementById('notch6_x5F_1'), document.getElementById('notch6_x5F_2'), document.getElementById('notch6_x5F_3'), 
            document.getElementById('notch6_x5F_4'), document.getElementById('notch6_x5F_5'), document.getElementById('notch6_x5F_6'), 
            document.getElementById('notch6_x5F_7'), document.getElementById('notch6_x5F_8'), document.getElementById('notch6_x5F_9'), 
            document.getElementById('notch6_x5F_10'), document.getElementById('notch6_x5F_11'), document.getElementById('notch6_x5F_12'),
            document.getElementById('notch6_x5F_13'), document.getElementById('notch6_x5F_14')],
        hpElem: 8100, toElem: '1202.4px 933px', toTopElem: '1316px 777px', hpOnePiece: 540, resPiece: 90, expPiece: 67, lvlRes: 2, 
        rarity: 9, numRarRes: 5, quantPiece: 13,
        hpPiece: [7560, 7020, 6480, 5940, 5400, 4860, 4320, 3780, 3240, 2700, 2160, 1620, 1080, 540, 0], 
    },  {  
        elemMA: document.getElementById('tree7'), allElem: document.getElementById('tree7'), 
        topElem: document.getElementById('top-tree7'), bottomElem: document.getElementById('bottom-tree7'), 
        piece: [document.getElementById('notch7_x5F_1'), document.getElementById('notch7_x5F_2'), document.getElementById('notch7_x5F_3'), 
            document.getElementById('notch7_x5F_4'), document.getElementById('notch7_x5F_5'), document.getElementById('notch7_x5F_6'), 
            document.getElementById('notch7_x5F_7'), document.getElementById('notch7_x5F_8'), document.getElementById('notch7_x5F_9'), 
            document.getElementById('notch7_x5F_10'), document.getElementById('notch7_x5F_11'), document.getElementById('notch7_x5F_12'),
            document.getElementById('notch7_x5F_13'), document.getElementById('notch7_x5F_14'), document.getElementById('notch7_x5F_15'),
            document.getElementById('notch7_x5F_16'), document.getElementById('notch7_x5F_17'),document.getElementById('notch7_x5F_18')],
        hpElem: 12160, toElem: '1201px 927px', toTopElem: '1349px 777px', hpOnePiece: 640, resPiece: 107, expPiece: 80, lvlRes: 2, 
        rarity: 9, numRarRes: 6, quantPiece: 17,
        hpPiece: [11520, 10880, 10240, 9600, 8960, 8320, 7680, 7040, 6400, 5760, 5120, 4480, 3840, 3200, 2560, 1929, 1280, 640, 0], 
    },  {  
        elemMA: document.getElementById('tree8'), allElem: document.getElementById('tree8'), 
        topElem: document.getElementById('top-tree8'), bottomElem: document.getElementById('bottom-tree8'), 
        piece: [document.getElementById('notch8_x5F_1'), document.getElementById('notch8_x5F_2'), document.getElementById('notch8_x5F_3'), 
            document.getElementById('notch8_x5F_4'), document.getElementById('notch8_x5F_5'), document.getElementById('notch8_x5F_6'), 
            document.getElementById('notch8_x5F_7'), document.getElementById('notch8_x5F_8'), document.getElementById('notch8_x5F_9'), 
            document.getElementById('notch8_x5F_10'), document.getElementById('notch8_x5F_11'), document.getElementById('notch8_x5F_12'),
            document.getElementById('notch8_x5F_13'), document.getElementById('notch8_x5F_14'), document.getElementById('notch8_x5F_15'),
            document.getElementById('notch8_x5F_16'), document.getElementById('notch8_x5F_17'),document.getElementById('notch8_x5F_18'), 
            document.getElementById('notch8_x5F_19'), document.getElementById('notch8_x5F_20')],
        hpElem: 18480, toElem: '1220px 923px', toTopElem: '1389px 777px', hpOnePiece: 880, resPiece: 147, expPiece: 110, lvlRes: 2, 
        rarity: 9, numRarRes: 8, quantPiece: 19,
        hpPiece: [17600, 16720, 15840, 14960, 14080, 13200, 12320, 11440, 10560, 9680, 8800, 7920, 7040, 6160, 5280, 4400, 3520, 2640, 1760, 
            880, 0], 
    },  {  
        elemMA: document.getElementById('tree9'), allElem: document.getElementById('tree9'), 
        topElem: document.getElementById('top-tree9'), bottomElem: document.getElementById('bottom-tree9'), 
        piece: [document.getElementById('notch9_x5F_1'), document.getElementById('notch9_x5F_2'), document.getElementById('notch9_x5F_3'), 
            document.getElementById('notch9_x5F_4'), document.getElementById('notch9_x5F_5'), document.getElementById('notch9_x5F_6'), 
            document.getElementById('notch9_x5F_7'), document.getElementById('notch9_x5F_8'), document.getElementById('notch9_x5F_9'), 
            document.getElementById('notch9_x5F_10'), document.getElementById('notch9_x5F_11'), document.getElementById('notch9_x5F_12'),
            document.getElementById('notch9_x5F_13'), document.getElementById('notch9_x5F_14'), document.getElementById('notch9_x5F_15'),
            document.getElementById('notch9_x5F_16'), document.getElementById('notch9_x5F_17'),document.getElementById('notch9_x5F_18'), 
            document.getElementById('notch9_x5F_19'), document.getElementById('notch9_x5F_20'), document.getElementById('notch9_x5F_21'),
            document.getElementById('notch9_x5F_22')],
        hpElem: 27600, toElem: '1223px 924px', toTopElem: '1440px 777px', hpOnePiece: 1200, resPiece: 200, expPiece: 150, lvlRes: 2, 
        rarity: 10, numRarRes: 10, quantPiece: 21,
        hpPiece: [26400, 25200, 24000, 22800, 21600, 20400, 19200, 18000, 16800, 15600, 14400, 13200, 12000, 10800, 9600, 8400, 7200, 6000, 4800, 3600, 2400, 1200, 0], 
    }, {  
        elemMA: document.getElementById('tree10'), allElem: document.getElementById('tree10'), 
        topElem: document.getElementById('top-tree10'), bottomElem: document.getElementById('bottom-tree10'), 
        piece: [document.getElementById('notch10_x5F_1'), document.getElementById('notch10_x5F_2'), document.getElementById('notch10_x5F_3'),
            document.getElementById('notch10_x5F_4'), document.getElementById('notch10_x5F_5'), document.getElementById('notch10_x5F_6'),
            document.getElementById('notch10_x5F_7'), document.getElementById('notch10_x5F_8'), document.getElementById('notch10_x5F_9'),
            document.getElementById('notch10_x5F_10'), document.getElementById('notch10_x5F_11'),
            document.getElementById('notch10_x5F_12'), document.getElementById('notch10_x5F_13'), 
            document.getElementById('notch10_x5F_14'), document.getElementById('notch10_x5F_15'),
            document.getElementById('notch10_x5F_16'), document.getElementById('notch10_x5F_17'),
            document.getElementById('notch10_x5F_18'), document.getElementById('notch10_x5F_19'), 
            document.getElementById('notch10_x5F_20'), document.getElementById('notch10_x5F_21'),
            document.getElementById('notch10_x5F_22'), document.getElementById('notch10_x5F_23'),
            document.getElementById('notch10_x5F_24')],
        hpElem: 41500, toElem: '1248px 933px', toTopElem: '1490px 777px', hpOnePiece: 1660, resPiece: 277, expPiece: 210, lvlRes: 2, 
        rarity: 10, numRarRes: 14, quantPiece: 23,
        hpPiece: [39840, 38180, 36520, 34860, 33200, 315400, 29880, 28220, 26560, 24900, 23240, 21580, 19920, 18260, 16600, 14940, 13280, 11620,
            9960, 8300, 6640, 4980, 3320, 1660, 0], 
    }, 
    { // Tree LVL 3 
        elemMA: document.getElementById('tree1'), allElem: document.getElementById('tree1'), 
        topElem: document.getElementById('top-tree1'), bottomElem: document.getElementById('bottom-tree1'), 
        piece: [document.getElementById('notch1_x5F_1'), document.getElementById('notch1_x5F_2'), document.getElementById('notch1_x5F_3'), 
            document.getElementById('notch1_x5F_4'), document.getElementById('notch1_x5F_5')],
        hpElem: 19200, toElem: '1191.5px 932.3px', toTopElem: '1238px 777px', hpOnePiece: 3200, resPiece: 540, expPiece: 400, lvlRes: 2, 
        rarity: 30, numRarRes: 27, quantPiece: 4, 
        hpPiece: [16000, 12800, 9600, 6400, 3200, 0], 
    }, { 
        elemMA: document.getElementById('tree2'), allElem: document.getElementById('tree2'), 
        topElem: document.getElementById('top-tree2'), bottomElem: document.getElementById('bottom-tree2'), 
        piece: [document.getElementById('notch2_x5F_1'), document.getElementById('notch2_x5F_2'), document.getElementById('notch2_x5F_3'), 
            document.getElementById('notch2_x5F_4'), document.getElementById('notch2_x5F_5'), document.getElementById('notch2_x5F_6')],
        hpElem: 30800, toElem: '1188px 932.3px', toTopElem: '1249px 777px', hpOnePiece: 4400, resPiece: 740, expPiece: 550, lvlRes: 2, 
        rarity: 30, numRarRes: 37, quantPiece: 5, 
        hpPiece: [26400, 22000, 17600, 13200, 8800, 4400, 0], 
    }, { 
        elemMA: document.getElementById('tree3'), allElem: document.getElementById('tree3'), 
        topElem: document.getElementById('top-tree3'), bottomElem: document.getElementById('bottom-tree3'), 
        piece: [document.getElementById('notch3_x5F_1'), document.getElementById('notch3_x5F_2'), document.getElementById('notch3_x5F_3'), 
            document.getElementById('notch3_x5F_4'), document.getElementById('notch3_x5F_5'), document.getElementById('notch3_x5F_6'), 
            document.getElementById('notch3_x5F_7'), document.getElementById('notch3_x5F_8'), document.getElementById('notch3_x5F_9')],
        hpElem: 52000, toElem: '1191.5px 932.3px', toTopElem: '1262px 777px', hpOnePiece: 5200, resPiece: 860,expPiece: 650, lvlRes: 2, 
        rarity: 30, numRarRes: 43, quantPiece: 8, 
        hpPiece: [46800, 41600, 36400, 31200, 26000, 20800, 15600, 10400, 5200, 0], 
    }, { 
        elemMA: document.getElementById('tree4'), allElem: document.getElementById('tree4'), 
        topElem: document.getElementById('top-tree4'), bottomElem: document.getElementById('bottom-tree4'), 
        piece: [document.getElementById('notch4_x5F_1'), document.getElementById('notch4_x5F_2'), document.getElementById('notch4_x5F_3'), 
            document.getElementById('notch4_x5F_4'), document.getElementById('notch4_x5F_5'), document.getElementById('notch4_x5F_6'), 
            document.getElementById('notch4_x5F_7'), document.getElementById('notch4_x5F_8'), document.getElementById('notch4_x5F_9')],
        hpElem: 72000, toElem: '1187.5px 932.3px', toTopElem: '1263px 777px', hpOnePiece: 7200, resPiece: 1200,expPiece: 900, lvlRes: 2, 
        rarity: 30, numRarRes: 60, quantPiece: 8, 
        hpPiece: [64800, 57600, 50400, 43200, 36000, 28800, 21600, 14400, 7200, 0], 
    }, { 
        elemMA: document.getElementById('tree5'), allElem: document.getElementById('tree5'), 
        topElem: document.getElementById('top-tree5'), bottomElem: document.getElementById('bottom-tree5'), 
        piece: [document.getElementById('notch5_x5F_1'), document.getElementById('notch5_x5F_2'), document.getElementById('notch5_x5F_3'), 
            document.getElementById('notch5_x5F_4'), document.getElementById('notch5_x5F_5'), document.getElementById('notch5_x5F_6'), 
            document.getElementById('notch5_x5F_7'), document.getElementById('notch5_x5F_8'), document.getElementById('notch5_x5F_9'), 
            document.getElementById('notch5_x5F_10'), document.getElementById('notch5_x5F_11'),document.getElementById('notch5_x5F_12')],
        hpElem: 109200, toElem: '1196.1px 932.3px', toTopElem: '1290px 777px', hpOnePiece: 8400, resPiece: 1400,expPiece: 1050, lvlRes: 2, 
        rarity: 30, numRarRes: 70, quantPiece: 11,
        hpPiece: [100800, 92400, 84000, 75600, 67200, 58800, 50400, 42000, 33600, 25200, 16800, 8400, 0], 
    }, {  
        elemMA: document.getElementById('tree6'), allElem: document.getElementById('tree6'), 
        topElem: document.getElementById('top-tree6'), bottomElem: document.getElementById('bottom-tree6'), 
        piece: [document.getElementById('notch6_x5F_1'), document.getElementById('notch6_x5F_2'), document.getElementById('notch6_x5F_3'), 
            document.getElementById('notch6_x5F_4'), document.getElementById('notch6_x5F_5'), document.getElementById('notch6_x5F_6'), 
            document.getElementById('notch6_x5F_7'), document.getElementById('notch6_x5F_8'), document.getElementById('notch6_x5F_9'), 
            document.getElementById('notch6_x5F_10'), document.getElementById('notch6_x5F_11'), document.getElementById('notch6_x5F_12'),
            document.getElementById('notch6_x5F_13'), document.getElementById('notch6_x5F_14')],
        hpElem: 162000, toElem: '1202.4px 933px', toTopElem: '1316px 777px', hpOnePiece: 10800, resPiece: 1800, expPiece: 1350, lvlRes: 2, 
        rarity: 30, numRarRes: 90, quantPiece: 13,
        hpPiece: [151200, 140400, 129600, 118800, 108000, 97200, 86400, 75600, 64800, 54000, 43200, 32400, 21600, 10800, 0], 
    },  {  
        elemMA: document.getElementById('tree7'), allElem: document.getElementById('tree7'), 
        topElem: document.getElementById('top-tree7'), bottomElem: document.getElementById('bottom-tree7'), 
        piece: [document.getElementById('notch7_x5F_1'), document.getElementById('notch7_x5F_2'), document.getElementById('notch7_x5F_3'), 
            document.getElementById('notch7_x5F_4'), document.getElementById('notch7_x5F_5'), document.getElementById('notch7_x5F_6'), 
            document.getElementById('notch7_x5F_7'), document.getElementById('notch7_x5F_8'), document.getElementById('notch7_x5F_9'), 
            document.getElementById('notch7_x5F_10'), document.getElementById('notch7_x5F_11'), document.getElementById('notch7_x5F_12'),
            document.getElementById('notch7_x5F_13'), document.getElementById('notch7_x5F_14'), document.getElementById('notch7_x5F_15'),
            document.getElementById('notch7_x5F_16'), document.getElementById('notch7_x5F_17'),document.getElementById('notch7_x5F_18')],
        hpElem: 243200, toElem: '1201px 927px', toTopElem: '1349px 777px', hpOnePiece: 12800, resPiece: 2140, expPiece: 1600, lvlRes: 2, 
        rarity: 30, numRarRes: 107, quantPiece: 17,
        hpPiece: [230400, 217600, 204800, 192000, 179200, 166400, 153600, 140800, 128000, 115200, 102400, 89600, 76800, 64000, 51200, 38580, 
            25600, 12800, 0], 
    },  {  
        elemMA: document.getElementById('tree8'), allElem: document.getElementById('tree8'), 
        topElem: document.getElementById('top-tree8'), bottomElem: document.getElementById('bottom-tree8'), 
        piece: [document.getElementById('notch8_x5F_1'), document.getElementById('notch8_x5F_2'), document.getElementById('notch8_x5F_3'), 
            document.getElementById('notch8_x5F_4'), document.getElementById('notch8_x5F_5'), document.getElementById('notch8_x5F_6'), 
            document.getElementById('notch8_x5F_7'), document.getElementById('notch8_x5F_8'), document.getElementById('notch8_x5F_9'), 
            document.getElementById('notch8_x5F_10'), document.getElementById('notch8_x5F_11'), document.getElementById('notch8_x5F_12'),
            document.getElementById('notch8_x5F_13'), document.getElementById('notch8_x5F_14'), document.getElementById('notch8_x5F_15'),
            document.getElementById('notch8_x5F_16'), document.getElementById('notch8_x5F_17'),document.getElementById('notch8_x5F_18'), 
            document.getElementById('notch8_x5F_19'), document.getElementById('notch8_x5F_20')],
        hpElem: 369600, toElem: '1220px 923px', toTopElem: '1389px 777px', hpOnePiece: 17600, resPiece: 2940, expPiece: 2200, lvlRes: 2, 
        rarity: 30, numRarRes: 147, quantPiece: 19,
        hpPiece: [352000, 334400, 316800, 299200, 281600, 264000, 246400, 228800, 211200, 193600, 176000, 158400, 140800, 123200, 105600, 
            88000, 70400, 52800, 35200, 17600, 0], 
    },  {  
        elemMA: document.getElementById('tree9'), allElem: document.getElementById('tree9'), 
        topElem: document.getElementById('top-tree9'), bottomElem: document.getElementById('bottom-tree9'), 
        piece: [document.getElementById('notch9_x5F_1'), document.getElementById('notch9_x5F_2'), document.getElementById('notch9_x5F_3'), 
            document.getElementById('notch9_x5F_4'), document.getElementById('notch9_x5F_5'), document.getElementById('notch9_x5F_6'), 
            document.getElementById('notch9_x5F_7'), document.getElementById('notch9_x5F_8'), document.getElementById('notch9_x5F_9'), 
            document.getElementById('notch9_x5F_10'), document.getElementById('notch9_x5F_11'), document.getElementById('notch9_x5F_12'),
            document.getElementById('notch9_x5F_13'), document.getElementById('notch9_x5F_14'), document.getElementById('notch9_x5F_15'),
            document.getElementById('notch9_x5F_16'), document.getElementById('notch9_x5F_17'),document.getElementById('notch9_x5F_18'), 
            document.getElementById('notch9_x5F_19'), document.getElementById('notch9_x5F_20'), document.getElementById('notch9_x5F_21'),
            document.getElementById('notch9_x5F_22')],
        hpElem: 552000, toElem: '1223px 924px', toTopElem: '1440px 777px', hpOnePiece: 24000, resPiece: 4000,expPiece: 3000, lvlRes: 2, 
        rarity: 30, numRarRes: 200, quantPiece: 21,
        hpPiece: [528000, 504000, 480000, 456000, 432000, 408000, 384000, 360000, 336000, 312000, 288000, 264000, 240000, 216000, 192000, 
            168000, 144000, 120000, 96000, 72000, 48000, 24000, 0], 
    }, {  
        elemMA: document.getElementById('tree10'), allElem: document.getElementById('tree10'), 
        topElem: document.getElementById('top-tree10'), bottomElem: document.getElementById('bottom-tree10'), 
        piece: [document.getElementById('notch10_x5F_1'), document.getElementById('notch10_x5F_2'), document.getElementById('notch10_x5F_3'),
            document.getElementById('notch10_x5F_4'), document.getElementById('notch10_x5F_5'), document.getElementById('notch10_x5F_6'),
            document.getElementById('notch10_x5F_7'), document.getElementById('notch10_x5F_8'), document.getElementById('notch10_x5F_9'),
            document.getElementById('notch10_x5F_10'), document.getElementById('notch10_x5F_11'),
            document.getElementById('notch10_x5F_12'), document.getElementById('notch10_x5F_13'), 
            document.getElementById('notch10_x5F_14'), document.getElementById('notch10_x5F_15'),
            document.getElementById('notch10_x5F_16'), document.getElementById('notch10_x5F_17'),
            document.getElementById('notch10_x5F_18'), document.getElementById('notch10_x5F_19'), 
            document.getElementById('notch10_x5F_20'), document.getElementById('notch10_x5F_21'),
            document.getElementById('notch10_x5F_22'), document.getElementById('notch10_x5F_23'),
            document.getElementById('notch10_x5F_24')],
        hpElem: 830000, toElem: '1248px 933px', toTopElem: '1490px 777px', hpOnePiece: 33200, resPiece: 5540,expPiece: 4150, lvlRes: 2, 
        rarity: 30, numRarRes: 277, quantPiece: 23,
        hpPiece: [796800, 763600, 730400, 697200, 664000, 630800, 597600, 564400, 531200, 498000, 464800, 431600, 398400, 365200, 332000, 
            298800, 265600, 232400, 199200, 166000, 132800, 99600, 66400, 33200, 0], 
    },
    { // Tree LVL 4 
        elemMA: document.getElementById('tree1'), allElem: document.getElementById('tree1'), 
        topElem: document.getElementById('top-tree1'), bottomElem: document.getElementById('bottom-tree1'), 
        piece: [document.getElementById('notch1_x5F_1'), document.getElementById('notch1_x5F_2'), document.getElementById('notch1_x5F_3'), 
            document.getElementById('notch1_x5F_4'), document.getElementById('notch1_x5F_5')],
        hpElem: 384000, toElem: '1191.5px 932.3px', toTopElem: '1238px 777px', hpOnePiece: 64000, resPiece: 540, expPiece: 8000, lvlRes: 3, 
        quantPiece: 4,  hpPiece: [320000, 256000, 192000, 128000, 64000, 0], 
    }, { 
        elemMA: document.getElementById('tree2'), allElem: document.getElementById('tree2'), 
        topElem: document.getElementById('top-tree2'), bottomElem: document.getElementById('bottom-tree2'), 
        piece: [document.getElementById('notch2_x5F_1'), document.getElementById('notch2_x5F_2'), document.getElementById('notch2_x5F_3'), 
            document.getElementById('notch2_x5F_4'), document.getElementById('notch2_x5F_5'), document.getElementById('notch2_x5F_6')],
        hpElem: 616000, toElem: '1188px 932.3px', toTopElem: '1249px 777px', hpOnePiece: 88000, resPiece: 740, expPiece: 11000, lvlRes: 3, 
        quantPiece: 5,  hpPiece: [528000, 440000, 352000, 264000, 176000, 88000, 0], 
    }, { 
        elemMA: document.getElementById('tree3'), allElem: document.getElementById('tree3'), 
        topElem: document.getElementById('top-tree3'), bottomElem: document.getElementById('bottom-tree3'), 
        piece: [document.getElementById('notch3_x5F_1'), document.getElementById('notch3_x5F_2'), document.getElementById('notch3_x5F_3'), 
            document.getElementById('notch3_x5F_4'), document.getElementById('notch3_x5F_5'), document.getElementById('notch3_x5F_6'), 
            document.getElementById('notch3_x5F_7'), document.getElementById('notch3_x5F_8'), document.getElementById('notch3_x5F_9')],
        hpElem: 1040000, toElem: '1191.5px 932.3px', toTopElem: '1262px 777px', hpOnePiece: 104000, resPiece: 860,expPiece: 13000, lvlRes: 3, 
        quantPiece: 8,  hpPiece: [936000, 832000, 728000, 624000, 520000, 416000, 312000, 208000, 104000, 0], 
    }, { 
        elemMA: document.getElementById('tree4'), allElem: document.getElementById('tree4'), 
        topElem: document.getElementById('top-tree4'), bottomElem: document.getElementById('bottom-tree4'), 
        piece: [document.getElementById('notch4_x5F_1'), document.getElementById('notch4_x5F_2'), document.getElementById('notch4_x5F_3'), 
            document.getElementById('notch4_x5F_4'), document.getElementById('notch4_x5F_5'), document.getElementById('notch4_x5F_6'), 
            document.getElementById('notch4_x5F_7'), document.getElementById('notch4_x5F_8'), document.getElementById('notch4_x5F_9')],
        hpElem: 1440000, toElem: '1187.5px 932.3px', toTopElem: '1263px 777px', hpOnePiece: 144000, resPiece: 1200,expPiece: 18000, lvlRes: 3, 
        quantPiece: 8,  hpPiece: [1296000, 1152000, 1008000, 864000, 720000, 576000, 432000, 288000, 144000, 0], 
    }, { 
        elemMA: document.getElementById('tree5'), allElem: document.getElementById('tree5'), 
        topElem: document.getElementById('top-tree5'), bottomElem: document.getElementById('bottom-tree5'), 
        piece: [document.getElementById('notch5_x5F_1'), document.getElementById('notch5_x5F_2'), document.getElementById('notch5_x5F_3'), 
            document.getElementById('notch5_x5F_4'), document.getElementById('notch5_x5F_5'), document.getElementById('notch5_x5F_6'), 
            document.getElementById('notch5_x5F_7'), document.getElementById('notch5_x5F_8'), document.getElementById('notch5_x5F_9'), 
            document.getElementById('notch5_x5F_10'), document.getElementById('notch5_x5F_11'),document.getElementById('notch5_x5F_12')],
        hpElem: 2184000, toElem: '1196.1px 932.3px', toTopElem: '1290px 777px', hpOnePiece: 168000, resPiece: 1400,expPiece: 21000, lvlRes: 3, 
        quantPiece: 11, hpPiece: [2016000, 1848000, 1680000, 1512000, 1344000, 1176000, 1008000, 840000, 672000, 504000, 336000, 168000, 0], 
    }, {  
        elemMA: document.getElementById('tree6'), allElem: document.getElementById('tree6'), 
        topElem: document.getElementById('top-tree6'), bottomElem: document.getElementById('bottom-tree6'), 
        piece: [document.getElementById('notch6_x5F_1'), document.getElementById('notch6_x5F_2'), document.getElementById('notch6_x5F_3'), 
            document.getElementById('notch6_x5F_4'), document.getElementById('notch6_x5F_5'), document.getElementById('notch6_x5F_6'), 
            document.getElementById('notch6_x5F_7'), document.getElementById('notch6_x5F_8'), document.getElementById('notch6_x5F_9'), 
            document.getElementById('notch6_x5F_10'), document.getElementById('notch6_x5F_11'), document.getElementById('notch6_x5F_12'),
            document.getElementById('notch6_x5F_13'), document.getElementById('notch6_x5F_14')],
        hpElem: 3240000, toElem: '1202.4px 933px', toTopElem: '1316px 777px', hpOnePiece: 216000, resPiece: 1800, expPiece: 27000, lvlRes: 3, 
        quantPiece: 13, hpPiece: [3024000, 2808000, 2592000, 2376000, 2160000, 1944000, 1728000, 1512000, 1296000, 1080000, 864000, 648000, 432000, 216000, 0], 
    },  {  
        elemMA: document.getElementById('tree7'), allElem: document.getElementById('tree7'), 
        topElem: document.getElementById('top-tree7'), bottomElem: document.getElementById('bottom-tree7'), 
        piece: [document.getElementById('notch7_x5F_1'), document.getElementById('notch7_x5F_2'), document.getElementById('notch7_x5F_3'), 
            document.getElementById('notch7_x5F_4'), document.getElementById('notch7_x5F_5'), document.getElementById('notch7_x5F_6'), 
            document.getElementById('notch7_x5F_7'), document.getElementById('notch7_x5F_8'), document.getElementById('notch7_x5F_9'), 
            document.getElementById('notch7_x5F_10'), document.getElementById('notch7_x5F_11'), document.getElementById('notch7_x5F_12'),
            document.getElementById('notch7_x5F_13'), document.getElementById('notch7_x5F_14'), document.getElementById('notch7_x5F_15'),
            document.getElementById('notch7_x5F_16'), document.getElementById('notch7_x5F_17'),document.getElementById('notch7_x5F_18')],
        hpElem: 4864000, toElem: '1201px 927px', toTopElem: '1349px 777px', hpOnePiece: 256000, resPiece: 2140, expPiece: 32000, lvlRes: 3, 
        quantPiece: 17, hpPiece: [4608000, 4352000, 4096000, 3840000, 3584000, 3328000, 3072000, 2816000, 2560000, 2304000, 2048000, 1792000, 1536000, 1280000, 1024000, 768000, 512000, 256000, 0], 
    },  {  
        elemMA: document.getElementById('tree8'), allElem: document.getElementById('tree8'), 
        topElem: document.getElementById('top-tree8'), bottomElem: document.getElementById('bottom-tree8'), 
        piece: [document.getElementById('notch8_x5F_1'), document.getElementById('notch8_x5F_2'), document.getElementById('notch8_x5F_3'), 
            document.getElementById('notch8_x5F_4'), document.getElementById('notch8_x5F_5'), document.getElementById('notch8_x5F_6'), 
            document.getElementById('notch8_x5F_7'), document.getElementById('notch8_x5F_8'), document.getElementById('notch8_x5F_9'), 
            document.getElementById('notch8_x5F_10'), document.getElementById('notch8_x5F_11'), document.getElementById('notch8_x5F_12'),
            document.getElementById('notch8_x5F_13'), document.getElementById('notch8_x5F_14'), document.getElementById('notch8_x5F_15'),
            document.getElementById('notch8_x5F_16'), document.getElementById('notch8_x5F_17'),document.getElementById('notch8_x5F_18'), 
            document.getElementById('notch8_x5F_19'), document.getElementById('notch8_x5F_20')],
        hpElem: 7392000, toElem: '1220px 923px', toTopElem: '1389px 777px', hpOnePiece: 352000, resPiece: 2940, expPiece: 44000, lvlRes: 3, 
        quantPiece: 19, hpPiece: [7040000, 66688000, 6336000, 5984000, 5632000, 5280000, 4928000, 4576000, 4224000, 3872000, 3520000, 3168000, 2816000, 2464000, 2112000, 1760000, 1408000, 1056000, 704000, 352000, 0], 
    },  {  
        elemMA: document.getElementById('tree9'), allElem: document.getElementById('tree9'), 
        topElem: document.getElementById('top-tree9'), bottomElem: document.getElementById('bottom-tree9'), 
        piece: [document.getElementById('notch9_x5F_1'), document.getElementById('notch9_x5F_2'), document.getElementById('notch9_x5F_3'), 
            document.getElementById('notch9_x5F_4'), document.getElementById('notch9_x5F_5'), document.getElementById('notch9_x5F_6'), 
            document.getElementById('notch9_x5F_7'), document.getElementById('notch9_x5F_8'), document.getElementById('notch9_x5F_9'), 
            document.getElementById('notch9_x5F_10'), document.getElementById('notch9_x5F_11'), document.getElementById('notch9_x5F_12'),
            document.getElementById('notch9_x5F_13'), document.getElementById('notch9_x5F_14'), document.getElementById('notch9_x5F_15'),
            document.getElementById('notch9_x5F_16'), document.getElementById('notch9_x5F_17'),document.getElementById('notch9_x5F_18'), 
            document.getElementById('notch9_x5F_19'), document.getElementById('notch9_x5F_20'), document.getElementById('notch9_x5F_21'),
            document.getElementById('notch9_x5F_22')],
        hpElem: 11040000, toElem: '1223px 924px', toTopElem: '1440px 777px', hpOnePiece: 480000, resPiece: 4000, expPiece: 60000, lvlRes: 3, 
        quantPiece: 21, hpPiece: [10560000, 10080000, 9600000, 9120000, 8640000, 8160000, 7680000, 7200000, 6720000, 6240000, 5760000, 5280000, 4800000, 4320000, 3840000, 3360000, 2880000, 2400000, 1920000, 1440000, 960000, 480000, 0], 
    }, {  
        elemMA: document.getElementById('tree10'), allElem: document.getElementById('tree10'), 
        topElem: document.getElementById('top-tree10'), bottomElem: document.getElementById('bottom-tree10'), 
        piece: [document.getElementById('notch10_x5F_1'), document.getElementById('notch10_x5F_2'), document.getElementById('notch10_x5F_3'),
            document.getElementById('notch10_x5F_4'), document.getElementById('notch10_x5F_5'), document.getElementById('notch10_x5F_6'),
            document.getElementById('notch10_x5F_7'), document.getElementById('notch10_x5F_8'), document.getElementById('notch10_x5F_9'),
            document.getElementById('notch10_x5F_10'), document.getElementById('notch10_x5F_11'),
            document.getElementById('notch10_x5F_12'), document.getElementById('notch10_x5F_13'), 
            document.getElementById('notch10_x5F_14'), document.getElementById('notch10_x5F_15'),
            document.getElementById('notch10_x5F_16'), document.getElementById('notch10_x5F_17'),
            document.getElementById('notch10_x5F_18'), document.getElementById('notch10_x5F_19'), 
            document.getElementById('notch10_x5F_20'), document.getElementById('notch10_x5F_21'),
            document.getElementById('notch10_x5F_22'), document.getElementById('notch10_x5F_23'),
            document.getElementById('notch10_x5F_24')],
        hpElem: 16600000, toElem: '1248px 933px', toTopElem: '1490px 777px', hpOnePiece: 664000, resPiece: 5540,expPiece: 83000, lvlRes: 3, 
        quantPiece: 23, hpPiece: [15936000, 15272000, 14608000, 13944000, 13280000, 12616000, 11952000, 11288000, 10624000, 9960000, 9296000, 8632000, 7968000, 7304000, 6640000, 5976000, 5312000, 4648000, 3984000, 3320000, 2656000, 1992000, 1328000, 664000, 0], 
    }     
];
// Массив обьектов параметров в конструктор CreatStones
creatStone = [
    { // Stones LVL 1
        allElem: document.getElementById('stone1'), 
        piece: [document.getElementById('piece1_x5F_1'), document.getElementById('piece1_x5F_2'), 
            document.getElementById('piece1_x5F_3'), document.getElementById('piece1_x5F_4'), document.getElementById('piece1_x5F_5'), 
            document.getElementById('piece1_x5F_6'), document.getElementById('piece1_x5F_7')],
        hpElem: 49, toElem: '1187px 930px', hpOnePiece: 7, resPiece: 1, expPiece: 1, lvlRes: 1, quantPiece: 7,
        hpPiece: [42, 35, 28, 21, 14, 7, 0]
    }, { 
        allElem: document.getElementById('stone2'), 
        piece: [document.getElementById('piece2_x5F_1'), document.getElementById('piece2_x5F_2'), 
            document.getElementById('piece2_x5F_3'), document.getElementById('piece2_x5F_4'), document.getElementById('piece2_x5F_5'), 
            document.getElementById('piece2_x5F_6'), document.getElementById('piece2_x5F_7'), document.getElementById('piece2_x5F_8'), 
            document.getElementById('piece2_x5F_9')],
        hpElem: 72, toElem: '1210px 930px', hpOnePiece: 8, resPiece: 1, expPiece: 1, lvlRes: 1, quantPiece: 8,
        hpPiece: [64, 56, 48, 40, 32, 24, 16, 8, 0] 
    }, {  
        allElem: document.getElementById('stone3'), 
        piece: [document.getElementById('piece3_x5F_1'), document.getElementById('piece3_x5F_2'), document.getElementById('piece3_x5F_3'),
                document.getElementById('piece3_x5F_4'), document.getElementById('piece3_x5F_5'), document.getElementById('piece3_x5F_6'),
                document.getElementById('piece3_x5F_7'), document.getElementById('piece3_x5F_8'), document.getElementById('piece3_x5F_9'), 
                document.getElementById('piece3_x5F_10'), document.getElementById('piece3_x5F_11')],
        hpElem: 121, toElem: '1192px 930px', hpOnePiece: 11, resPiece: 2, expPiece: 1, lvlRes: 1, quantPiece: 10,
        hpPiece: [110, 99, 88, 77, 66, 55, 44, 33, 22, 11, 0]
    }, { 
        allElem: document.getElementById('stone4'), 
        piece: [document.getElementById('piece4_x5F_1'), document.getElementById('piece4_x5F_2'), document.getElementById('piece4_x5F_3'), 
                document.getElementById('piece4_x5F_4'), document.getElementById('piece4_x5F_5'), document.getElementById('piece4_x5F_6'), 
                document.getElementById('piece4_x5F_7'), document.getElementById('piece4_x5F_8'), document.getElementById('piece4_x5F_9'), 
                document.getElementById('piece4_x5F_10'), document.getElementById('piece4_x5F_11'), document.getElementById('piece4_x5F_12'), 
                document.getElementById('piece4_x5F_13'), document.getElementById('piece4_x5F_14')],
        hpElem: 182, toElem: '1203px 930px', hpOnePiece: 13, resPiece: 2, expPiece: 2, lvlRes: 1, quantPiece: 13,
        hpPiece: [169, 156, 143, 130, 117, 104, 91, 78, 65, 52, 39, 26, 13, 0] 
    }, { 
        allElem: document.getElementById('stone5'), 
        piece: [document.getElementById('piece5_x5F_1'), document.getElementById('piece5_x5F_2'), document.getElementById('piece5_x5F_3'), 
                document.getElementById('piece5_x5F_4'), document.getElementById('piece5_x5F_5'), document.getElementById('piece5_x5F_6'), 
                document.getElementById('piece5_x5F_7'), document.getElementById('piece5_x5F_8'), document.getElementById('piece5_x5F_9'), 
                document.getElementById('piece5_x5F_10'), document.getElementById('piece5_x5F_11'), document.getElementById('piece5_x5F_12'), 
                document.getElementById('piece5_x5F_13'), document.getElementById('piece5_x5F_14'), document.getElementById('piece5_x5F_15'), 
                document.getElementById('piece5_x5F_16')],
        hpElem: 288, toElem: '1204px 918px', hpOnePiece: 18, resPiece: 3, expPiece: 2, lvlRes: 1, quantPiece: 15,
        hpPiece: [270, 252, 234, 216, 198, 180, 162, 144, 126, 108, 90, 72, 54, 36, 18, 0]
    }, {  
        allElem: document.getElementById('stone6'), 
        piece: [document.getElementById('piece6_x5F_1'), document.getElementById('piece6_x5F_2'), document.getElementById('piece6_x5F_3'), 
                document.getElementById('piece6_x5F_4'), document.getElementById('piece6_x5F_5'), document.getElementById('piece6_x5F_6'), 
                document.getElementById('piece6_x5F_7'), document.getElementById('piece6_x5F_8'), document.getElementById('piece6_x5F_9'), 
                document.getElementById('piece6_x5F_10'), document.getElementById('piece6_x5F_11'), document.getElementById('piece6_x5F_12'), 
                document.getElementById('piece6_x5F_13'), document.getElementById('piece6_x5F_14'), document.getElementById('piece6_x5F_15'), 
                document.getElementById('piece6_x5F_16'), document.getElementById('piece6_x5F_17'), document.getElementById('piece6_x5F_18')],
        hpElem: 432, toElem: '1220px 913px', hpOnePiece: 24, resPiece: 4, expPiece: 3, lvlRes: 1, quantPiece: 17,
        hpPiece: [408, 384, 360, 336, 312, 288, 264, 240, 216, 192, 168, 144, 120, 96, 72, 48, 24, 0] 
    }, {  
        allElem: document.getElementById('stone7'), 
        piece: [document.getElementById('piece7_x5F_1'), document.getElementById('piece7_x5F_2'), document.getElementById('piece7_x5F_3'), 
                document.getElementById('piece7_x5F_4'), document.getElementById('piece7_x5F_5'), document.getElementById('piece7_x5F_6'), 
                document.getElementById('piece7_x5F_7'), document.getElementById('piece7_x5F_8'), document.getElementById('piece7_x5F_9'), 
                document.getElementById('piece7_x5F_10'), document.getElementById('piece7_x5F_11'), document.getElementById('piece7_x5F_12'),
                document.getElementById('piece7_x5F_13'), document.getElementById('piece7_x5F_14'), document.getElementById('piece7_x5F_15'),
                document.getElementById('piece7_x5F_16'), document.getElementById('piece7_x5F_17'),document.getElementById('piece7_x5F_18'),
                document.getElementById('piece7_x5F_19'),document.getElementById('piece7_x5F_20'),document.getElementById('piece7_x5F_21')],
        hpElem: 651, toElem: '1220px 916px', hpOnePiece: 31, resPiece: 5, expPiece: 4, lvlRes: 1, quantPiece: 20,
        hpPiece: [620, 589, 558, 527, 496, 465, 434, 403, 372, 341, 310, 279, 248, 217, 186, 155, 124, 93, 62, 31, 0] 
    }, {  
        allElem: document.getElementById('stone8'), 
        piece: [document.getElementById('piece8_x5F_1'), document.getElementById('piece8_x5F_2'), document.getElementById('piece8_x5F_3'), 
                document.getElementById('piece8_x5F_4'), document.getElementById('piece8_x5F_5'), document.getElementById('piece8_x5F_6'), 
                document.getElementById('piece8_x5F_7'), document.getElementById('piece8_x5F_8'), document.getElementById('piece8_x5F_9'), 
                document.getElementById('piece8_x5F_10'), document.getElementById('piece8_x5F_11'), document.getElementById('piece8_x5F_12'),
                document.getElementById('piece8_x5F_13'), document.getElementById('piece8_x5F_14'), document.getElementById('piece8_x5F_15'),
                document.getElementById('piece8_x5F_16'), document.getElementById('piece8_x5F_17'),document.getElementById('piece8_x5F_18'), 
                document.getElementById('piece8_x5F_19'), document.getElementById('piece8_x5F_20'), document.getElementById('piece8_x5F_21'), 
                document.getElementById('piece8_x5F_22'), document.getElementById('piece8_x5F_23'), document.getElementById('piece8_x5F_24')],
        hpElem: 960, toElem: '1275px 907px', hpOnePiece: 40, resPiece: 7, expPiece: 5, lvlRes: 1, quantPiece: 23,
        hpPiece: [920, 880, 840, 800, 760, 720, 680, 640, 600, 560, 520, 480, 440, 400, 360, 320, 280, 240, 200, 160, 120, 80, 40, 0] 
    }, {  
        allElem: document.getElementById('stone9'), 
        piece: [document.getElementById('piece9_x5F_1'), document.getElementById('piece9_x5F_2'), document.getElementById('piece9_x5F_3'), 
                document.getElementById('piece9_x5F_4'), document.getElementById('piece9_x5F_5'), document.getElementById('piece9_x5F_6'), 
                document.getElementById('piece9_x5F_7'), document.getElementById('piece9_x5F_8'), document.getElementById('piece9_x5F_9'), 
                document.getElementById('piece9_x5F_10'), document.getElementById('piece9_x5F_11'), document.getElementById('piece9_x5F_12'),
                document.getElementById('piece9_x5F_13'), document.getElementById('piece9_x5F_14'), document.getElementById('piece9_x5F_15'),
                document.getElementById('piece9_x5F_16'), document.getElementById('piece9_x5F_17'),document.getElementById('piece9_x5F_18'), 
                document.getElementById('piece9_x5F_19'), document.getElementById('piece9_x5F_20'), document.getElementById('piece9_x5F_21'), 
                document.getElementById('piece9_x5F_22'), document.getElementById('piece9_x5F_23'), document.getElementById('piece9_x5F_24')],
        hpElem: 1440, toElem: '1311px 908px', hpOnePiece: 60, resPiece: 10, expPiece: 7, lvlRes: 1, quantPiece: 23,
        hpPiece: [1380, 1320, 1260, 1200, 1140, 1080, 1020, 960, 900, 840, 780, 720, 660, 600, 540, 480, 420, 360, 300, 240, 180, 120, 60, 0]
    }, {   
        allElem: document.getElementById('stone10'), 
        piece: [document.getElementById('piece10_x5F_1'), document.getElementById('piece10_x5F_2'), document.getElementById('piece10_x5F_3'),
                document.getElementById('piece10_x5F_4'), document.getElementById('piece10_x5F_5'), document.getElementById('piece10_x5F_6'),
                document.getElementById('piece10_x5F_7'), document.getElementById('piece10_x5F_8'), document.getElementById('piece10_x5F_9'),
                document.getElementById('piece10_x5F_10'), document.getElementById('piece10_x5F_11'), document.getElementById('piece10_x5F_12'), 
                document.getElementById('piece10_x5F_13'), document.getElementById('piece10_x5F_14'), document.getElementById('piece10_x5F_15'),
                document.getElementById('piece10_x5F_16'), document.getElementById('piece10_x5F_17'), document.getElementById('piece10_x5F_18'), 
                document.getElementById('piece10_x5F_19'), document.getElementById('piece10_x5F_20'), document.getElementById('piece10_x5F_21'),
                document.getElementById('piece10_x5F_22'), document.getElementById('piece10_x5F_23'),document.getElementById('piece10_x5F_24'), 
                document.getElementById('piece10_x5F_25'), document.getElementById('piece10_x5F_26')],
        hpElem: 2158, toElem: '1421px 930px', hpOnePiece: 83, resPiece: 14, expPiece: 10, lvlRes: 1, quantPiece: 25,
        hpPiece:[2075, 1992, 1909, 1826, 1743, 1660, 1577, 1494, 1411, 1328, 1245, 1162, 1079, 996, 913, 830, 747, 664, 581, 498, 415, 332, 249, 166, 83, 0]
    }, 
    { // Stones LVL 2
        allElem: document.getElementById('stone11'), 
        piece: [document.getElementById('piece11_x5F_1'), document.getElementById('piece11_x5F_2'), 
            document.getElementById('piece11_x5F_3'), document.getElementById('piece11_x5F_4'), document.getElementById('piece11_x5F_5'),
            document.getElementById('piece11_x5F_6'), document.getElementById('piece11_x5F_7')],
        hpElem: 980, toElem: '1187px 930px', hpOnePiece: 140, resPiece: 23, expPiece: 17, lvlRes: 2, rarity: 6, numRarRes: 2, quantPiece: 6,
        hpPiece: [840, 700, 560, 420, 280, 140, 0]
    }, { 
        allElem: document.getElementById('stone12'), 
        piece: [document.getElementById('piece12_x5F_1'), document.getElementById('piece12_x5F_2'), 
            document.getElementById('piece12_x5F_3'), document.getElementById('piece12_x5F_4'), document.getElementById('piece12_x5F_5'), 
            document.getElementById('piece12_x5F_6'), document.getElementById('piece12_x5F_7'), document.getElementById('piece12_x5F_8'), 
            document.getElementById('piece12_x5F_9')],
        hpElem: 1440, toElem: '1210px 930px', hpOnePiece: 160, resPiece: 27, expPiece: 20, lvlRes: 2, rarity: 7, numRarRes: 2, quantPiece: 8,
        hpPiece: [1280, 1120, 960, 800, 640, 480, 320, 160, 0]
    }, {  
        allElem: document.getElementById('stone13'), 
        piece: [document.getElementById('piece13_x5F_1'), document.getElementById('piece13_x5F_2'), document.getElementById('piece13_x5F_3'),
                document.getElementById('piece13_x5F_4'), document.getElementById('piece13_x5F_5'), document.getElementById('piece13_x5F_6'),
                document.getElementById('piece13_x5F_7'), document.getElementById('piece13_x5F_8'), document.getElementById('piece13_x5F_9'), 
                document.getElementById('piece13_x5F_10'), document.getElementById('piece13_x5F_11')],
        hpElem: 2420, toElem: '1192px 930px', hpOnePiece: 220, resPiece: 37, expPiece: 27, lvlRes: 2, rarity: 9, numRarRes: 2, quantPiece: 10,
        hpPiece: [2200, 1980, 1760, 1540, 1320, 1100, 880, 660, 440, 220, 0]
    }, { 
        allElem: document.getElementById('stone14'), 
        piece: [document.getElementById('piece14_x5F_1'), document.getElementById('piece14_x5F_2'), document.getElementById('piece14_x5F_3'), 
                document.getElementById('piece14_x5F_4'), document.getElementById('piece14_x5F_5'), document.getElementById('piece14_x5F_6'), 
                document.getElementById('piece14_x5F_7'), document.getElementById('piece14_x5F_8'), document.getElementById('piece14_x5F_9'), 
                document.getElementById('piece14_x5F_10'), document.getElementById('piece14_x5F_11'), document.getElementById('piece14_x5F_12'), 
                document.getElementById('piece14_x5F_13'), document.getElementById('piece14_x5F_14')],
        hpElem: 3640, toElem: '1203px 930px', hpOnePiece: 260, resPiece: 43, expPiece: 32, lvlRes: 2, rarity: 7, numRarRes: 3, quantPiece: 13,
        hpPiece: [3380, 3120, 2860, 2600, 2340, 2080, 1820, 1660, 1400, 1040, 780, 520, 260, 0]
    }, { 
        allElem: document.getElementById('stone15'), 
        piece: [document.getElementById('piece15_x5F_1'), document.getElementById('piece15_x5F_2'), document.getElementById('piece15_x5F_3'), 
                document.getElementById('piece15_x5F_4'), document.getElementById('piece15_x5F_5'), document.getElementById('piece15_x5F_6'), 
                document.getElementById('piece15_x5F_7'), document.getElementById('piece15_x5F_8'), document.getElementById('piece15_x5F_9'), 
                document.getElementById('piece15_x5F_10'), document.getElementById('piece15_x5F_11'), document.getElementById('piece15_x5F_12'), 
                document.getElementById('piece15_x5F_13'), document.getElementById('piece15_x5F_14'), document.getElementById('piece15_x5F_15'), 
                document.getElementById('piece15_x5F_16')],
        hpElem: 5760, toElem: '1204px 918px', hpOnePiece: 360, resPiece: 60, expPiece: 45, lvlRes: 2, rarity: 10, numRarRes: 3, quantPiece: 15,
        hpPiece: [5400, 5040, 4680, 4320, 3960, 3600, 3240, 2880, 2520, 2160, 1800, 1440, 1080, 720, 360, 0]
    }, {  
        allElem: document.getElementById('stone16'), 
        piece: [document.getElementById('piece16_x5F_1'), document.getElementById('piece16_x5F_2'), document.getElementById('piece16_x5F_3'), 
                document.getElementById('piece16_x5F_4'), document.getElementById('piece16_x5F_5'), document.getElementById('piece16_x5F_6'), 
                document.getElementById('piece16_x5F_7'), document.getElementById('piece16_x5F_8'), document.getElementById('piece16_x5F_9'), 
                document.getElementById('piece16_x5F_10'), document.getElementById('piece16_x5F_11'), document.getElementById('piece16_x5F_12'), 
                document.getElementById('piece16_x5F_13'), document.getElementById('piece16_x5F_14'), document.getElementById('piece16_x5F_15'), 
                document.getElementById('piece16_x5F_16'), document.getElementById('piece16_x5F_17'), document.getElementById('piece16_x5F_18')],
        hpElem: 8640, toElem: '1220px 913px', hpOnePiece: 480, resPiece: 80, expPiece: 60, lvlRes: 2, rarity: 10, numRarRes: 4, quantPiece: 17,
        hpPiece: [8160, 7680, 7200, 6720, 6240, 5760, 5280, 4800, 4320, 3840, 3360, 2880, 2400, 1920, 1440, 960, 480, 0]
    }, {  
        allElem: document.getElementById('stone17'), 
        piece: [document.getElementById('piece17_x5F_1'), document.getElementById('piece17_x5F_2'), document.getElementById('piece17_x5F_3'), 
                document.getElementById('piece17_x5F_4'), document.getElementById('piece17_x5F_5'), document.getElementById('piece17_x5F_6'), 
                document.getElementById('piece17_x5F_7'), document.getElementById('piece17_x5F_8'), document.getElementById('piece17_x5F_9'), 
                document.getElementById('piece17_x5F_10'), document.getElementById('piece17_x5F_11'), document.getElementById('piece17_x5F_12'),
                document.getElementById('piece17_x5F_13'), document.getElementById('piece17_x5F_14'), document.getElementById('piece17_x5F_15'),
                document.getElementById('piece17_x5F_16'), document.getElementById('piece17_x5F_17'),document.getElementById('piece17_x5F_18'),
                document.getElementById('piece17_x5F_19'),document.getElementById('piece17_x5F_20'),document.getElementById('piece17_x5F_21')],
        hpElem: 13020, toElem: '1220px 916px', hpOnePiece: 620, resPiece: 103, expPiece: 77, lvlRes: 2, rarity: 9, numRarRes: 6, quantPiece: 20,
        hpPiece: [12400, 11780, 11160, 10540, 9920, 9300, 8680, 8060, 7440, 6820, 6200, 5580, 4960, 4340, 3720, 3100, 2480, 1860, 1240, 620, 0]  
    }, {  
        allElem: document.getElementById('stone18'), 
        piece: [document.getElementById('piece18_x5F_1'), document.getElementById('piece18_x5F_2'), document.getElementById('piece18_x5F_3'), 
                document.getElementById('piece18_x5F_4'), document.getElementById('piece18_x5F_5'), document.getElementById('piece18_x5F_6'), 
                document.getElementById('piece18_x5F_7'), document.getElementById('piece18_x5F_8'), document.getElementById('piece18_x5F_9'), 
                document.getElementById('piece18_x5F_10'), document.getElementById('piece18_x5F_11'), document.getElementById('piece18_x5F_12'),
                document.getElementById('piece18_x5F_13'), document.getElementById('piece18_x5F_14'), document.getElementById('piece18_x5F_15'),
                document.getElementById('piece18_x5F_16'), document.getElementById('piece18_x5F_17'),document.getElementById('piece18_x5F_18'), 
                document.getElementById('piece18_x5F_19'), document.getElementById('piece18_x5F_20'), document.getElementById('piece18_x5F_21'), 
                document.getElementById('piece18_x5F_22'), document.getElementById('piece18_x5F_23'), document.getElementById('piece18_x5F_24')],
        hpElem: 19200, toElem: '1275px 907px', hpOnePiece: 800, resPiece: 133, expPiece: 100, lvlRes: 2, rarity: 10, numRarRes: 7, 
        quantPiece: 23, hpPiece: [18400, 17600, 16800, 16000, 15200, 14400, 13600, 12800, 12000, 11200, 10400, 9600, 8800, 8000, 7200, 6400, 5600, 4800, 4000, 3200, 2400, 1600, 800, 0]  
    }, {  
        allElem: document.getElementById('stone19'), 
        piece: [document.getElementById('piece19_x5F_1'), document.getElementById('piece19_x5F_2'), document.getElementById('piece19_x5F_3'), 
                document.getElementById('piece19_x5F_4'), document.getElementById('piece19_x5F_5'), document.getElementById('piece19_x5F_6'), 
                document.getElementById('piece19_x5F_7'), document.getElementById('piece19_x5F_8'), document.getElementById('piece19_x5F_9'), 
                document.getElementById('piece19_x5F_10'), document.getElementById('piece19_x5F_11'), document.getElementById('piece19_x5F_12'),
                document.getElementById('piece19_x5F_13'), document.getElementById('piece19_x5F_14'), document.getElementById('piece19_x5F_15'),
                document.getElementById('piece19_x5F_16'), document.getElementById('piece19_x5F_17'),document.getElementById('piece19_x5F_18'), 
                document.getElementById('piece19_x5F_19'), document.getElementById('piece19_x5F_20'), document.getElementById('piece19_x5F_21'), 
                document.getElementById('piece19_x5F_22'), document.getElementById('piece19_x5F_23'), document.getElementById('piece19_x5F_24')],
        hpElem: 28800, toElem: '1311px 908px', hpOnePiece: 1200, resPiece: 200, expPiece: 150, lvlRes: 2, rarity: 10,numRarRes: 10,
        quantPiece: 23, hpPiece: [27600, 26400, 25200, 24000, 22800, 21600, 20400, 19200, 18000, 16800, 15600, 14400, 13200, 12000, 10800, 9600, 8400, 7200, 6000, 4800, 3600, 2400, 1200, 0]
    }, {   
        allElem: document.getElementById('stone20'), 
        piece: [document.getElementById('piece20_x5F_1'), document.getElementById('piece20_x5F_2'), document.getElementById('piece20_x5F_3'),
                document.getElementById('piece20_x5F_4'), document.getElementById('piece20_x5F_5'), document.getElementById('piece20_x5F_6'),
                document.getElementById('piece20_x5F_7'), document.getElementById('piece20_x5F_8'), document.getElementById('piece20_x5F_9'),
                document.getElementById('piece20_x5F_10'), document.getElementById('piece20_x5F_11'), document.getElementById('piece20_x5F_12'), 
                document.getElementById('piece20_x5F_13'), document.getElementById('piece20_x5F_14'), document.getElementById('piece20_x5F_15'),
                document.getElementById('piece20_x5F_16'), document.getElementById('piece20_x5F_17'), document.getElementById('piece20_x5F_18'), 
                document.getElementById('piece20_x5F_19'), document.getElementById('piece20_x5F_20'), document.getElementById('piece20_x5F_21'),
                document.getElementById('piece20_x5F_22'), document.getElementById('piece20_x5F_23'),document.getElementById('piece20_x5F_24'), 
                document.getElementById('piece20_x5F_25'), document.getElementById('piece20_x5F_26')],
        hpElem: 43160, toElem: '1421px 930px', hpOnePiece: 1660, resPiece: 277, expPiece: 207, lvlRes: 2, rarity: 10,numRarRes: 14,
        quantPiece: 25, hpPiece:[41500, 39840, 38180, 36520, 34860, 33200, 31540, 29880, 28220, 26560, 24900, 23240, 21580, 19920, 18260, 16600, 14940, 13280, 11620, 9960, 8300, 6640, 4980, 3320, 1660, 0]
    }, 
    { // Stones LVL 3
        allElem: document.getElementById('stone21'), 
        piece: [document.getElementById('piece21_x5F_1'), document.getElementById('piece21_x5F_2'), 
            document.getElementById('piece21_x5F_3'), document.getElementById('piece21_x5F_4'), document.getElementById('piece21_x5F_5'),
            document.getElementById('piece21_x5F_6'), document.getElementById('piece21_x5F_7')],
        hpElem: 19600, toElem: '1187px 930px', hpOnePiece: 2800, resPiece: 460, expPiece: 350, lvlRes: 2, rarity: 30, numRarRes: 23,
        quantPiece: 6, hpPiece: [16800, 14000, 11200, 8400, 5600, 2800, 0]
    }, { 
        allElem: document.getElementById('stone22'), 
        piece: [document.getElementById('piece22_x5F_1'), document.getElementById('piece22_x5F_2'), 
            document.getElementById('piece22_x5F_3'), document.getElementById('piece22_x5F_4'), document.getElementById('piece22_x5F_5'), 
            document.getElementById('piece22_x5F_6'), document.getElementById('piece22_x5F_7'), document.getElementById('piece22_x5F_8'), 
            document.getElementById('piece22_x5F_9')],
        hpElem: 28800, toElem: '1210px 930px', hpOnePiece: 3200, resPiece: 540, expPiece: 400, lvlRes: 2, rarity: 30, numRarRes: 27,  
        quantPiece: 8, hpPiece: [25600, 22400, 19200, 16000, 12800, 9600, 6400, 3200, 0]
    }, {  
        allElem: document.getElementById('stone23'), 
        piece: [document.getElementById('piece23_x5F_1'), document.getElementById('piece23_x5F_2'), document.getElementById('piece23_x5F_3'),
                document.getElementById('piece23_x5F_4'), document.getElementById('piece23_x5F_5'), document.getElementById('piece23_x5F_6'),
                document.getElementById('piece23_x5F_7'), document.getElementById('piece23_x5F_8'), document.getElementById('piece23_x5F_9'), 
                document.getElementById('piece23_x5F_10'), document.getElementById('piece23_x5F_11')],
        hpElem: 48400, toElem: '1192px 930px', hpOnePiece: 4400, resPiece: 740, expPiece: 550, lvlRes: 2, rarity: 30, numRarRes: 37,  
        quantPiece: 10, hpPiece: [44000, 39600, 35200, 30800, 26400, 22000, 17600, 13200, 8800, 4400, 0]
    }, { 
        allElem: document.getElementById('stone24'), 
        piece: [document.getElementById('piece24_x5F_1'), document.getElementById('piece24_x5F_2'), document.getElementById('piece24_x5F_3'), 
                document.getElementById('piece24_x5F_4'), document.getElementById('piece24_x5F_5'), document.getElementById('piece24_x5F_6'), 
                document.getElementById('piece24_x5F_7'), document.getElementById('piece24_x5F_8'), document.getElementById('piece24_x5F_9'), 
                document.getElementById('piece24_x5F_10'), document.getElementById('piece24_x5F_11'), document.getElementById('piece24_x5F_12'), 
                document.getElementById('piece24_x5F_13'), document.getElementById('piece24_x5F_14')],
        hpElem: 72800, toElem: '1203px 930px', hpOnePiece: 5200, resPiece: 860, expPiece: 650, lvlRes: 2, rarity: 30, numRarRes: 43,  
        quantPiece: 13, hpPiece: [67600, 62400, 57200, 52000, 46800, 41600, 36400, 31200, 26000, 20800, 15600, 10400, 5200, 0]
    }, { 
        allElem: document.getElementById('stone25'), 
        piece: [document.getElementById('piece25_x5F_1'), document.getElementById('piece25_x5F_2'), document.getElementById('piece25_x5F_3'), 
                document.getElementById('piece25_x5F_4'), document.getElementById('piece25_x5F_5'), document.getElementById('piece25_x5F_6'), 
                document.getElementById('piece25_x5F_7'), document.getElementById('piece25_x5F_8'), document.getElementById('piece25_x5F_9'), 
                document.getElementById('piece25_x5F_10'), document.getElementById('piece25_x5F_11'), document.getElementById('piece25_x5F_12'), 
                document.getElementById('piece25_x5F_13'), document.getElementById('piece25_x5F_14'), document.getElementById('piece25_x5F_15'), 
                document.getElementById('piece25_x5F_16')],
        hpElem: 115200, toElem: '1204px 918px', hpOnePiece: 7200, resPiece: 1200, expPiece: 900, lvlRes: 2, rarity: 30, numRarRes: 60,  
        quantPiece: 15, hpPiece: [108000, 100800, 93600, 86400, 79200, 72000, 64800, 57600, 50400, 43200, 36000, 28800, 21600, 14400, 7200, 0]
    }, {  
        allElem: document.getElementById('stone26'), 
        piece: [document.getElementById('piece26_x5F_1'), document.getElementById('piece26_x5F_2'), document.getElementById('piece26_x5F_3'), 
                document.getElementById('piece26_x5F_4'), document.getElementById('piece26_x5F_5'), document.getElementById('piece26_x5F_6'), 
                document.getElementById('piece26_x5F_7'), document.getElementById('piece26_x5F_8'), document.getElementById('piece26_x5F_9'), 
                document.getElementById('piece26_x5F_10'), document.getElementById('piece26_x5F_11'), document.getElementById('piece26_x5F_12'), 
                document.getElementById('piece26_x5F_13'), document.getElementById('piece26_x5F_14'), document.getElementById('piece26_x5F_15'), 
                document.getElementById('piece26_x5F_16'), document.getElementById('piece26_x5F_17'), document.getElementById('piece26_x5F_18')],
        hpElem: 172800, toElem: '1220px 913px', hpOnePiece: 9600, resPiece: 1600, expPiece: 1200, lvlRes: 2, rarity: 30, numRarRes: 80,  
        quantPiece: 17, hpPiece: [163200, 153600, 144000, 134400, 124800, 115200, 105600, 96000, 86400, 76800, 67200, 57600, 48000, 38400, 28800, 19200, 9600, 0]
    }, {  
        allElem: document.getElementById('stone27'), 
        piece: [document.getElementById('piece27_x5F_1'), document.getElementById('piece27_x5F_2'), document.getElementById('piece27_x5F_3'), 
                document.getElementById('piece27_x5F_4'), document.getElementById('piece27_x5F_5'), document.getElementById('piece27_x5F_6'), 
                document.getElementById('piece27_x5F_7'), document.getElementById('piece27_x5F_8'), document.getElementById('piece27_x5F_9'), 
                document.getElementById('piece27_x5F_10'), document.getElementById('piece27_x5F_11'), document.getElementById('piece27_x5F_12'),
                document.getElementById('piece27_x5F_13'), document.getElementById('piece27_x5F_14'), document.getElementById('piece27_x5F_15'),
                document.getElementById('piece27_x5F_16'), document.getElementById('piece27_x5F_17'),document.getElementById('piece27_x5F_18'),
                document.getElementById('piece27_x5F_19'),document.getElementById('piece27_x5F_20'),document.getElementById('piece27_x5F_21')],
        hpElem: 260400, toElem: '1220px 916px', hpOnePiece: 12400, resPiece: 2100, expPiece: 1550, lvlRes: 2, rarity: 30, numRarRes: 105,  
        quantPiece: 20, hpPiece: [248000, 235600, 223200, 210800, 198400, 186000, 173600, 161200, 148800, 136400, 124000, 111600, 99200, 86800, 74400, 62000, 49600, 37200, 24800, 12400, 0]  
    }, {  
        allElem: document.getElementById('stone28'), 
        piece: [document.getElementById('piece28_x5F_1'), document.getElementById('piece28_x5F_2'), document.getElementById('piece28_x5F_3'), 
                document.getElementById('piece28_x5F_4'), document.getElementById('piece28_x5F_5'), document.getElementById('piece28_x5F_6'), 
                document.getElementById('piece28_x5F_7'), document.getElementById('piece28_x5F_8'), document.getElementById('piece28_x5F_9'), 
                document.getElementById('piece28_x5F_10'), document.getElementById('piece28_x5F_11'), document.getElementById('piece28_x5F_12'),
                document.getElementById('piece28_x5F_13'), document.getElementById('piece28_x5F_14'), document.getElementById('piece28_x5F_15'),
                document.getElementById('piece28_x5F_16'), document.getElementById('piece28_x5F_17'),document.getElementById('piece28_x5F_18'), 
                document.getElementById('piece28_x5F_19'), document.getElementById('piece28_x5F_20'), document.getElementById('piece28_x5F_21'), 
                document.getElementById('piece28_x5F_22'), document.getElementById('piece28_x5F_23'), document.getElementById('piece28_x5F_24')],
        hpElem: 384000, toElem: '1275px 907px', hpOnePiece: 16000, resPiece: 2700, expPiece: 2000, lvlRes: 2, rarity: 30, numRarRes: 135,  
        quantPiece: 23, hpPiece: [368000, 352000, 336000, 320000, 304000, 288000, 272000, 256000, 240000, 224000, 208000, 192000, 176000, 160000, 144000, 128000, 112000, 96000, 80000, 64000, 48000, 32000, 16000, 0]  
    }, {  
        allElem: document.getElementById('stone29'), 
        piece: [document.getElementById('piece29_x5F_1'), document.getElementById('piece29_x5F_2'), document.getElementById('piece29_x5F_3'), 
                document.getElementById('piece29_x5F_4'), document.getElementById('piece29_x5F_5'), document.getElementById('piece29_x5F_6'), 
                document.getElementById('piece29_x5F_7'), document.getElementById('piece29_x5F_8'), document.getElementById('piece29_x5F_9'), 
                document.getElementById('piece29_x5F_10'), document.getElementById('piece29_x5F_11'), document.getElementById('piece29_x5F_12'),
                document.getElementById('piece29_x5F_13'), document.getElementById('piece29_x5F_14'), document.getElementById('piece29_x5F_15'),
                document.getElementById('piece29_x5F_16'), document.getElementById('piece29_x5F_17'),document.getElementById('piece29_x5F_18'), 
                document.getElementById('piece29_x5F_19'), document.getElementById('piece29_x5F_20'), document.getElementById('piece29_x5F_21'), 
                document.getElementById('piece29_x5F_22'), document.getElementById('piece29_x5F_23'), document.getElementById('piece29_x5F_24')],
        hpElem: 576000, toElem: '1311px 908px', hpOnePiece: 24000, resPiece: 4000, expPiece: 3000, lvlRes: 2, rarity: 30, numRarRes: 200,  
        quantPiece: 23, hpPiece: [552000, 528000, 504000, 480000, 456000, 432000, 408000, 384000, 360000, 336000, 312000, 288000, 264000, 240000, 216000, 192000, 168000, 144000, 120000, 96000, 72000, 48000, 24000, 0]
    }, {   
        allElem: document.getElementById('stone30'), 
        piece: [document.getElementById('piece30_x5F_1'), document.getElementById('piece30_x5F_2'), document.getElementById('piece30_x5F_3'),
                document.getElementById('piece30_x5F_4'), document.getElementById('piece30_x5F_5'), document.getElementById('piece30_x5F_6'),
                document.getElementById('piece30_x5F_7'), document.getElementById('piece30_x5F_8'), document.getElementById('piece30_x5F_9'),
                document.getElementById('piece30_x5F_10'), document.getElementById('piece30_x5F_11'), document.getElementById('piece30_x5F_12'), 
                document.getElementById('piece30_x5F_13'), document.getElementById('piece30_x5F_14'), document.getElementById('piece30_x5F_15'),
                document.getElementById('piece30_x5F_16'), document.getElementById('piece30_x5F_17'), document.getElementById('piece30_x5F_18'), 
                document.getElementById('piece30_x5F_19'), document.getElementById('piece30_x5F_20'), document.getElementById('piece30_x5F_21'),
                document.getElementById('piece30_x5F_22'), document.getElementById('piece30_x5F_23'),document.getElementById('piece30_x5F_24'), 
                document.getElementById('piece30_x5F_25'), document.getElementById('piece30_x5F_26')],
        hpElem: 863200, toElem: '1421px 930px', hpOnePiece: 33200, resPiece: 5600, expPiece: 4150, lvlRes: 2, rarity: 30, numRarRes: 280,  
        quantPiece: 25, hpPiece:[830000, 796800, 763600, 730400, 697200, 664000, 630800, 597600, 564400, 531200, 498000, 464800, 431600, 398400, 365200, 332000, 298800, 265600, 232400, 199200, 166000, 132800, 99600, 66400, 33200, 0]
    },
    { // Stones LVL 4
        allElem: document.getElementById('stone31'), 
        piece: [document.getElementById('piece31_x5F_1'), document.getElementById('piece31_x5F_2'), 
            document.getElementById('piece31_x5F_3'), document.getElementById('piece31_x5F_4'), document.getElementById('piece31_x5F_5'),
            document.getElementById('piece31_x5F_6'), document.getElementById('piece31_x5F_7')],
        hpElem: 392000, toElem: '1187px 930px', hpOnePiece: 56000, resPiece: 460, expPiece: 7000, lvlRes: 3, quantPiece: 6,
        hpPiece: [336000, 280000, 224000, 168000, 112000, 56000, 0]
    }, { 
        allElem: document.getElementById('stone32'), 
        piece: [document.getElementById('piece32_x5F_1'), document.getElementById('piece32_x5F_2'), 
            document.getElementById('piece32_x5F_3'), document.getElementById('piece32_x5F_4'), document.getElementById('piece32_x5F_5'), 
            document.getElementById('piece32_x5F_6'), document.getElementById('piece32_x5F_7'), document.getElementById('piece32_x5F_8'), 
            document.getElementById('piece32_x5F_9')],
        hpElem: 576000, toElem: '1210px 930px', hpOnePiece: 64000, resPiece: 540, expPiece: 8000, lvlRes: 3, quantPiece: 8,
        hpPiece: [512000, 448000, 384000, 320000, 256000, 192000, 128000, 64000, 0]
    }, {  
        allElem: document.getElementById('stone33'), 
        piece: [document.getElementById('piece33_x5F_1'), document.getElementById('piece33_x5F_2'), document.getElementById('piece33_x5F_3'),
                document.getElementById('piece33_x5F_4'), document.getElementById('piece33_x5F_5'), document.getElementById('piece33_x5F_6'),
                document.getElementById('piece33_x5F_7'), document.getElementById('piece33_x5F_8'), document.getElementById('piece33_x5F_9'), 
                document.getElementById('piece33_x5F_10'), document.getElementById('piece33_x5F_11')],
        hpElem: 968000, toElem: '1192px 930px', hpOnePiece: 88000, resPiece: 740, expPiece: 11000, lvlRes: 3, quantPiece: 10,
        hpPiece: [880000, 792000, 704000, 616000, 528000, 440000, 352000, 264000, 176000, 88000, 0]
    }, { 
        allElem: document.getElementById('stone34'), 
        piece: [document.getElementById('piece34_x5F_1'), document.getElementById('piece34_x5F_2'), document.getElementById('piece34_x5F_3'), 
                document.getElementById('piece34_x5F_4'), document.getElementById('piece34_x5F_5'), document.getElementById('piece34_x5F_6'), 
                document.getElementById('piece34_x5F_7'), document.getElementById('piece34_x5F_8'), document.getElementById('piece34_x5F_9'), 
                document.getElementById('piece34_x5F_10'), document.getElementById('piece34_x5F_11'), document.getElementById('piece34_x5F_12'), 
                document.getElementById('piece34_x5F_13'), document.getElementById('piece34_x5F_14')],
        hpElem: 1456000, toElem: '1203px 930px', hpOnePiece: 104000, resPiece: 860, expPiece: 13000, lvlRes: 3, quantPiece: 13,
        hpPiece: [1352000, 1248000, 1144000, 1040000, 936000, 832000, 728000, 624000, 520000, 416000, 312000, 208000, 104000, 0]
    }, { 
        allElem: document.getElementById('stone35'), 
        piece: [document.getElementById('piece35_x5F_1'), document.getElementById('piece35_x5F_2'), document.getElementById('piece35_x5F_3'), 
                document.getElementById('piece35_x5F_4'), document.getElementById('piece35_x5F_5'), document.getElementById('piece35_x5F_6'), 
                document.getElementById('piece35_x5F_7'), document.getElementById('piece35_x5F_8'), document.getElementById('piece35_x5F_9'), 
                document.getElementById('piece35_x5F_10'), document.getElementById('piece35_x5F_11'), document.getElementById('piece35_x5F_12'), 
                document.getElementById('piece35_x5F_13'), document.getElementById('piece35_x5F_14'), document.getElementById('piece35_x5F_15'), 
                document.getElementById('piece35_x5F_16')],
        hpElem: 2304000, toElem: '1204px 918px', hpOnePiece: 144000, resPiece: 1200, expPiece: 18000, lvlRes: 3, quantPiece: 15,
        hpPiece: [2160000, 2016000, 1872000, 1728000, 1584000, 1440000, 1296000, 1152000, 1008000, 864000, 720000, 576000, 432000, 288000, 
            144000, 0]
    }, {  
        allElem: document.getElementById('stone36'), 
        piece: [document.getElementById('piece36_x5F_1'), document.getElementById('piece36_x5F_2'), document.getElementById('piece36_x5F_3'), 
                document.getElementById('piece36_x5F_4'), document.getElementById('piece36_x5F_5'), document.getElementById('piece36_x5F_6'), 
                document.getElementById('piece36_x5F_7'), document.getElementById('piece36_x5F_8'), document.getElementById('piece36_x5F_9'), 
                document.getElementById('piece36_x5F_10'), document.getElementById('piece36_x5F_11'), document.getElementById('piece36_x5F_12'), 
                document.getElementById('piece36_x5F_13'), document.getElementById('piece36_x5F_14'), document.getElementById('piece36_x5F_15'), 
                document.getElementById('piece36_x5F_16'), document.getElementById('piece36_x5F_17'), document.getElementById('piece36_x5F_18')],
        hpElem: 3456000, toElem: '1220px 913px', hpOnePiece: 192000, resPiece: 1600, expPiece: 24000, lvlRes: 3, quantPiece: 17,
        hpPiece: [3264000, 3072000, 2880000, 2688000, 2496000, 2304000, 2112000, 1920000, 1728000, 1536000, 1344000, 1152000, 960000, 768000, 576000, 384000, 192000, 0]
    }, {  
        allElem: document.getElementById('stone37'), 
        piece: [document.getElementById('piece37_x5F_1'), document.getElementById('piece37_x5F_2'), document.getElementById('piece37_x5F_3'), 
                document.getElementById('piece37_x5F_4'), document.getElementById('piece37_x5F_5'), document.getElementById('piece37_x5F_6'), 
                document.getElementById('piece37_x5F_7'), document.getElementById('piece37_x5F_8'), document.getElementById('piece37_x5F_9'), 
                document.getElementById('piece37_x5F_10'), document.getElementById('piece37_x5F_11'), document.getElementById('piece37_x5F_12'),
                document.getElementById('piece37_x5F_13'), document.getElementById('piece37_x5F_14'), document.getElementById('piece37_x5F_15'),
                document.getElementById('piece37_x5F_16'), document.getElementById('piece37_x5F_17'),document.getElementById('piece37_x5F_18'),
                document.getElementById('piece37_x5F_19'),document.getElementById('piece37_x5F_20'),document.getElementById('piece37_x5F_21')],
        hpElem: 5208000, toElem: '1220px 916px', hpOnePiece: 248000, resPiece: 2100, expPiece: 31000, lvlRes: 3, quantPiece: 20,
        hpPiece: [4960000, 4712000, 4464000, 4216000, 3968000, 3720000, 3472000, 3224000, 2976000, 2728000, 2480000, 2232000, 1984000, 1736000, 1488000, 1240000, 992000, 744000, 496000, 248000, 0]  
    }, {  
        allElem: document.getElementById('stone38'), 
        piece: [document.getElementById('piece38_x5F_1'), document.getElementById('piece38_x5F_2'), document.getElementById('piece38_x5F_3'), 
                document.getElementById('piece38_x5F_4'), document.getElementById('piece38_x5F_5'), document.getElementById('piece38_x5F_6'), 
                document.getElementById('piece38_x5F_7'), document.getElementById('piece38_x5F_8'), document.getElementById('piece38_x5F_9'), 
                document.getElementById('piece38_x5F_10'), document.getElementById('piece38_x5F_11'), document.getElementById('piece38_x5F_12'),
                document.getElementById('piece38_x5F_13'), document.getElementById('piece38_x5F_14'), document.getElementById('piece38_x5F_15'),
                document.getElementById('piece38_x5F_16'), document.getElementById('piece38_x5F_17'),document.getElementById('piece38_x5F_18'), 
                document.getElementById('piece38_x5F_19'), document.getElementById('piece38_x5F_20'), document.getElementById('piece38_x5F_21'), 
                document.getElementById('piece38_x5F_22'), document.getElementById('piece38_x5F_23'), document.getElementById('piece38_x5F_24')],
        hpElem: 7680000, toElem: '1275px 907px', hpOnePiece: 320000, resPiece: 2700, expPiece: 40000, lvlRes: 3, quantPiece: 23,
        hpPiece: [7360000, 7040000, 6720000, 6400000, 6080000, 5760000, 5440000, 5120000, 4800000, 4480000, 4160000, 3840000, 3520000, 3200000, 2880000, 2560000, 2240000, 1920000, 1600000, 1280000, 960000, 640000, 320000, 0]  
    }, {  
        allElem: document.getElementById('stone39'), 
        piece: [document.getElementById('piece39_x5F_1'), document.getElementById('piece39_x5F_2'), document.getElementById('piece39_x5F_3'), 
                document.getElementById('piece39_x5F_4'), document.getElementById('piece39_x5F_5'), document.getElementById('piece39_x5F_6'), 
                document.getElementById('piece39_x5F_7'), document.getElementById('piece39_x5F_8'), document.getElementById('piece39_x5F_9'), 
                document.getElementById('piece39_x5F_10'), document.getElementById('piece39_x5F_11'), document.getElementById('piece39_x5F_12'),
                document.getElementById('piece39_x5F_13'), document.getElementById('piece39_x5F_14'), document.getElementById('piece39_x5F_15'),
                document.getElementById('piece39_x5F_16'), document.getElementById('piece39_x5F_17'),document.getElementById('piece39_x5F_18'), 
                document.getElementById('piece39_x5F_19'), document.getElementById('piece39_x5F_20'), document.getElementById('piece39_x5F_21'), 
                document.getElementById('piece39_x5F_22'), document.getElementById('piece39_x5F_23'), document.getElementById('piece39_x5F_24')],
        hpElem: 11520000, toElem: '1311px 908px', hpOnePiece: 480000, resPiece: 4000, expPiece: 60000, lvlRes: 3, quantPiece: 23,
        hpPiece: [11040000, 10560000, 10080000, 9600000, 9120000, 8640000, 8160000, 7680000, 7200000, 6720000, 6240000, 5760000, 5280000, 
            4800000, 4320000, 3840000, 3360000, 2880000, 2400000, 1920000, 1440000, 960000, 480000, 0]
    }, {   
        allElem: document.getElementById('stone40'), 
        piece: [document.getElementById('piece40_x5F_1'), document.getElementById('piece40_x5F_2'), document.getElementById('piece40_x5F_3'),
                document.getElementById('piece40_x5F_4'), document.getElementById('piece40_x5F_5'), document.getElementById('piece40_x5F_6'),
                document.getElementById('piece40_x5F_7'), document.getElementById('piece40_x5F_8'), document.getElementById('piece40_x5F_9'),
                document.getElementById('piece40_x5F_10'), document.getElementById('piece40_x5F_11'), document.getElementById('piece40_x5F_12'), 
                document.getElementById('piece40_x5F_13'), document.getElementById('piece40_x5F_14'), document.getElementById('piece40_x5F_15'),
                document.getElementById('piece40_x5F_16'), document.getElementById('piece40_x5F_17'), document.getElementById('piece40_x5F_18'), 
                document.getElementById('piece40_x5F_19'), document.getElementById('piece40_x5F_20'), document.getElementById('piece40_x5F_21'),
                document.getElementById('piece40_x5F_22'), document.getElementById('piece40_x5F_23'),document.getElementById('piece40_x5F_24'), 
                document.getElementById('piece40_x5F_25'), document.getElementById('piece40_x5F_26')],
        hpElem: 17264000, toElem: '1421px 930px', hpOnePiece: 664000, resPiece: 5600, expPiece: 83000, lvlRes: 3, quantPiece: 25,
        hpPiece:[16600000, 15936000, 15272000, 14608000, 13944000, 13280000, 12616000, 11952000, 11288000, 10624000, 9960000, 9296000, 8632000, 7968000, 7304000, 6640000, 5976000, 5312000, 4648000, 3984000, 3320000, 2656000, 1992000, 1328000, 664000, 0]
    }   
];

// Функция падения дерева ********************************************************************************************************************
let rotFallElem = 0, treeOpac = 1;
function deadTree() {
    let rotNum1 = 0; 
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;  
    function rafDeadElem() {
        deadElemIntrv = requestAnimationFrame(rafDeadElem); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            }
	        rotNum1 += 0.05 * k; rotFallElem += rotNum1;
	        // Падение, исчезновение дерева и старт движения
	        if (rotFallElem >= 104) {
	            rotFallElem = 104; 
	            treeOpac -= 0.05 * k; elem.allElem.style.opacity = treeOpac + ''; 
	            if (treeOpac <= 0) {
	            	deadTree2();
		            if (charMenu.style.display !== 'block' && optMenu.style.display !== 'block' && mesMainMA.style.display !== 'block') { 
				        walkChar(); moveCharStart(); 
				    }
				}
	        } elem.topElem.style.transform = 'rotate(' + rotFallElem + 'deg)'; 
	        k = 0;
	    }
    } rafDeadElem();
} 
function deadTree2() {
	let i;
	cancelAnimationFrame(deadElemIntrv); deadElemIntrv = null; actName = 'walk'; onesUpSpeed = false;
	// Исчезновение МО дерева и появление элементов дерева
    elem.allElem.style.display = 'none'; elem.piece.forEach(function(item) {item.style.display = 'block';});
    treeOpac = 1; elem.allElem.style.opacity = treeOpac; 
    rotFallElem = 0; elem.topElem.style.transform = 'rotate(' + rotFallElem + 'deg)';
    // Увеличение номера дерева
    creatElemNum += 1; 
    // Смена заливки элементов деревьев
    if (creatElemNum == 40) {
        creatElemNum = 0;
        fillTreeFlag = 1;
        for (i = 0; i < elem.fillTree.length; i++) elem.fillTree[i].style.fill = '#bf723d';
        for (i = 0; i < elem.fillTree2.length; i++) elem.fillTree2[i].style.fill = '#d48f63';
        for (i = 0; i < elem.fillPattern.length; i++) elem.fillPattern[i].style.fill = '#9f4d30';
    } else if (creatElemNum == 30 && fillTreeFlag !== 4) {
        fillTreeFlag = 4;
        for (i = 0; i < elem.fillTree.length; i++) elem.fillTree[i].style.fill = '#420000';
        for (i = 0; i < elem.fillTree2.length; i++) elem.fillTree2[i].style.fill = '#6b1515';
        for (i = 0; i < elem.fillPattern.length; i++) elem.fillPattern[i].style.fill = '#300300';
    } else if (creatElemNum == 20 && fillTreeFlag !== 3) {
        fillTreeFlag = 3;
        for (i = 0; i < elem.fillTree.length; i++) elem.fillTree[i].style.fill = '#601b00';
        for (i = 0; i < elem.fillTree2.length; i++) elem.fillTree2[i].style.fill = '#84331a';
        for (i = 0; i < elem.fillPattern.length; i++) elem.fillPattern[i].style.fill = '#490300';
    } else if (creatElemNum == 10 && fillTreeFlag !== 2) {
        fillTreeFlag = 2;
        for (i = 0; i < elem.fillTree.length; i++) elem.fillTree[i].style.fill = '#8c3900';
        for (i = 0; i < elem.fillTree2.length; i++) elem.fillTree2[i].style.fill = '#a85720';
        for (i = 0; i < elem.fillPattern.length; i++) elem.fillPattern[i].style.fill = '#701503';
    } // Создание следующего дерева
    elem = new CreatTrees(creatTree[creatElemNum]); elem.allElem.style.transform = 'translateX(' + elem.left_elem + '%)';
    elem.allElem.style.display = 'block'; elem.allElem.style.opacity = 1; elem.allElem.style.left = elem.left_elem + '%';
    elem.allElem.style.transformOrigin = elem.toElem; elem.topElem.style.transformOrigin = elem.toTopElem;    
}


// Функция уничтожения камня ***********************************************************************************************************
let deadStoneTimeout = null;
function deadStone() {
    // Init new stone and start move char
    if (charMenu.style.display !== 'block' && optMenu.style.display !== 'block' && mesMainMA.style.display !== 'block') {
        deadStoneTimeout = setTimeout(function() {
        	deadStone2();
        	if (charMenu.style.display !== 'block' && optMenu.style.display !== 'block' && mesMainMA.style.display !== 'block') { 
        		walkChar(); moveCharStart();
        	}
        }, 1000); 
    } 
}
function deadStone2() { 
	clearTimeout(deadStoneTimeout); deadStoneTimeout = null; actName = 'walk'; onesUpSpeed = false; 
	elem.allElem.style.display = 'none'; elem.piece.forEach(function(item) {item.style.display = 'block';});
	// Увеличение номера камня
    creatElemNum += 1; if (creatElemNum > 39) creatElemNum = 0;
    // Создание следующего камня
    elem = new CreatStones(creatStone[creatElemNum]); elem.allElem.style.transform = 'translateX(' + elem.left_elem + '%)';
    elem.allElem.style.display = 'block'; elem.allElem.style.left = elem.left_elem + '%';
    elem.allElem.style.transformOrigin = elem.toElem;     
}


// Функции потрясывания дерева или камня и инструментов после удара *****************************************************************************
function shakingElem() {
    let rotElemDir = 'plus', rotElem = 0;
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;         
    function rafShakingElem() {
        shakeIntrv = requestAnimationFrame(rafShakingElem); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            }
	        if (rotElemDir == 'plus') {
	        	rotElem += 0.2 * k; if (rotElem >= 0.5) rotElemDir = 'minus';
	        } else if (rotElemDir == 'minus') {
	        	rotElem -= 0.2 * k; if (rotElem <= -0.5) rotElemDir = 'plus';
	        } elem.allElem.style.transform = 'rotate(' + rotElem + 'deg)';
	        k = 0;
	    }
    } rafShakingElem();
}





// EVENT LISTENER clickArea ################################################################################################################
// Удары топорами и кирками *****************************************************************************
let onesHitClick = false, // Флаг единственного клика по главному экрану
hitIntrv = null, onesHitMove = false, // Интервал удара и флаг единственного запуска
backIntrv = null, // Интервал возврата элементов
downRotSpIntrv = null, onesUpSpeed = false, // Интервал и флаги в downRotSpeed()
hitPos2Flag = false, // Флаг единственного захода в таймаут для hitPos2
hitPos = 1, // Номер позиции удара
downRotSpeedFlag = false, // Флаг единственного выполнения функции уменшения rotSpeed
// Интервалы элементов показа урона, опыта, ресурсов
showDamIntrvl = null, showExpIntrvl = null, showResIntrvl = null, timerShowExp = null, timerShowRes = null, timerShowDam = null,
// Данные бензопил и перфораторов ***********************************************************************
shakingTools2, // Function
shakingTools2Intrvl = null, // Интервал тряски бензопилы и перфоратора
damTools2Intrv = null, // Интервал урона бензопилой и перфоратором
// Названия действия, 'hits' or 'walk'
actName = 'walk', 
damage = null, rotSpeed = 0.5, rotBackSpeed = 0.5,
// Суммы градусов углов поворота элементов 
hba_rot = 0, head_rot = 0,
r_arm_rot = 0, fr_arm_rot = 0, r_palm_rot = 0, l_arm_rot = 0, fl_arm_rot = 0, l_palm_rot = 0,
r_leg_rot = 0, fr_leg_rot = 0, r_foot_rot = 0, l_leg_rot = 0, fl_leg_rot = 0, l_foot_rot = 0;  

// Event listener clickArea ****************************************************************************************************************
clickArea.addEventListener(clickDownEvent, clickStart, false); 
clickArea.addEventListener(clickUpEvent, clickEnd, false);

function clickStart() {
	if (!onesHitClick && locNum > 1) {
		onesHitClick = true;
	    if (toolsName == 'ex' || toolsName == 'pick') {
	        // cancelAnimationFrame(downRotSpIntrv); 
	        // Увеличение скорости и запуск функции downRotSpeed()
	        if (!onesUpSpeed) {
	            if (numUsePot == 1 && actName == 'hits') rotSpeed += charData.speedPlus * 1.5;
	            else if ((numUsePot == 3 || numUsePot == 4) && actName == 'hits') rotSpeed += charData.speedPlus * 2;
	            else rotSpeed += charData.speedPlus;
	            if (!downRotSpeedFlag) downRotSpeed(); 
	            if (rotSpeed > 0.8) faceAnim();
	        } // Aspd and aspd record 
	        if (rotSpeed > recordData.aspdRecNum && actName == 'hits') {
	            recordData.aspdRecNum = rotSpeed; aspdRecShow.innerHTML = Math.round(recordData.aspdRecNum * 10) / 10;
	            window.localStorage.setItem("dataRecords3", JSON.stringify(recordData)); 
	            aspdShow.innerHTML = Math.round(rotSpeed * 10) / 10; // show aspd
	        } // Запуск функции hitMove()
	        if (!onesHitMove) {
	            onesHitMove = true; hitMove();
	        } 
	    } else if (actName == 'hits' && elem.hpElem > 0) {
	    	// if (!onesHitMove) {
	        //     onesHitMove = true; 
	        // } 
	    	clickTools2();
	    }
	}
}
function clickSaw() {
    onesHitMove = true; notPushBtnFlag = true; cancelAnimationFrame(backIntrv); 
    rightPupil.style.transform = 'translate(2px, 2px)'; leftPupil.style.transform = 'translate(2px, 2px)';
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;  
    function rafClickSaw() {
        hitIntrv = requestAnimationFrame(rafClickSaw); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            } // Body
	        if (hba_rot < 5) hba_rot += 0.1 * k;
	        if (head_rot < 5) head_rot += 0.1 * k;
	        // Righr arm
	        if (r_arm_rot > -30) r_arm_rot -= 0.4 * k; 
	        if (r_palm_rot > 20) r_palm_rot -= 0.2 * k; 
	        // Left arm
	        if (fl_arm_rot > -75) fl_arm_rot -= 0.9 * k;
	        // Касание бензопилой дерева
	        if (r_arm_rot <= -30 && fl_arm_rot <= -75 && r_palm_rot <= 20) { 
	            if (volumeData.soundFlag == 'on') hit2Sound.play();
	            r_arm_rot = -30; fl_arm_rot = -75; r_palm_rot = 20;
	            cancelAnimationFrame(hitIntrv); hitIntrv = null;
	            shakingTools2(); damageSawPerf();
	        } // Transform rotate
	        hba.style.transform = 'rotate(' + hba_rot + 'deg)'; head.style.transform = 'rotate(' + head_rot + 'deg)';
	        rightArm.style.transform = 'rotate(' + r_arm_rot + 'deg)'; firRightArm.style.transform = 'rotate(' + fr_arm_rot + 'deg)';
	        rightPalm.style.transform = 'rotate(' + r_palm_rot + 'deg)';
	        leftArm.style.transform = 'rotate(' + l_arm_rot + 'deg)'; firLeftArm.style.transform = 'rotate(' + fl_arm_rot + 'deg)';
	        leftPalm.style.transform = 'rotate(' + l_palm_rot + 'deg)';
	        k = 0;
	    }
    } rafClickSaw();
}
function clickPerf() {
    onesHitMove = true; notPushBtnFlag = true; cancelAnimationFrame(backIntrv); 
    rightPupil.style.transform = 'translate(2px, 2px)'; leftPupil.style.transform = 'translate(2px, 2px)';
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;  
    function rafClickPerf() {
        hitIntrv = requestAnimationFrame(rafClickPerf); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            } // Body
	        if (hba_rot < 5) hba_rot += 0.12 * k;
	        if (head_rot < 5) head_rot += 0.12 * k;
	        // Righr arm
	        if (r_arm_rot < 18) r_arm_rot += 0.2 * k; 
	        if (fr_arm_rot < -50) fr_arm_rot += 0.25 * k;
	        if (r_palm_rot < -20) r_palm_rot += 0.2 * k; 
	        // Left arm
	        if (fl_arm_rot < -5) fl_arm_rot += 1.5 * k;
	        // Касание бензопилой дерева
	        if (r_arm_rot >= 18 && fl_arm_rot >= -5 && r_palm_rot >= -20) { 
	            if (volumeData.soundFlag == 'on') hit2Sound.play();
	            r_arm_rot = 18; fl_arm_rot = -5; r_palm_rot = -20;
	            cancelAnimationFrame(hitIntrv); hitIntrv = null;
	            shakingTools2(); damageSawPerf();
	        } // Transform rotate
	        hba.style.transform = 'rotate(' + hba_rot + 'deg)'; head.style.transform = 'rotate(' + head_rot + 'deg)';
	        rightArm.style.transform = 'rotate(' + r_arm_rot + 'deg)'; firRightArm.style.transform = 'rotate(' + fr_arm_rot + 'deg)';
	        rightPalm.style.transform = 'rotate(' + r_palm_rot + 'deg)';
	        leftArm.style.transform = 'rotate(' + l_arm_rot + 'deg)'; firLeftArm.style.transform = 'rotate(' + fl_arm_rot + 'deg)';
	        leftPalm.style.transform = 'rotate(' + l_palm_rot + 'deg)';
	        k = 0;
	    }
    } rafClickPerf();
}  
function clickEnd() {
	onesHitClick = false;
    // if (toolsName == 'ex' || toolsName == 'pick') {}
    // else 
    if (toolsName == 'saw' || toolsName == 'perf') { 
    	notPushBtnFlag = false;
        if (actName == 'hits') {
            cancelAnimationFrame(hitIntrv); hitIntrv = null;
            cancelAnimationFrame(damTools2Intrv); 
            cancelAnimationFrame(shakeIntrv); cancelAnimationFrame(shakingTools2Intrvl); 
            if (elem.hpElem > 0) backMoveTools2();
        } else if (actName == 'walk') {
            // Запуск функции downRotSpeed()
            if (!onesUpSpeed) {
                rotSpeed += charData.speedPlus; if (rotSpeed > 0.8) faceAnim();
                if (!downRotSpeedFlag) downRotSpeed();
            } 
        } //console.log('onesUpSpeed ' + onesUpSpeed);
        //console.log('downRotSpeedFlag ' + downRotSpeedFlag);
    }
}

// Уменьшение скорости **************************************************************************************************************************
function downRotSpeed() {
    let last = performance.now(), step = 50, dt = 0; 
    downRotSpeedFlag = true;
    function rafDownRotSpeed() {
        downRotSpIntrv = requestAnimationFrame(rafDownRotSpeed);
        let now = performance.now(); dt += (now - last); last = now; 
        if (dt > step) { 
            dt -= step; 
            if (actName == 'hits') {
            	aspdShow.innerHTML = Math.round(rotSpeed * 10) / 10; 
                rotSpeed -= 0.05;
            } else if (actName == 'walk') rotSpeed -= 0.1;
            if (rotSpeed <= 0.5) {
                rotSpeed = 0.5; faceBackAnim(); cancelAnimationFrame(downRotSpIntrv); downRotSpeedFlag = false;
                if (actName == 'hits') aspdShow.innerHTML = Math.round(rotSpeed * 10) / 10;
            }
        }
    } rafDownRotSpeed(); // Запуск функции
}

// Удар топорами или кирками ********************************************************************************************************************
function hitMove() {
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;         
    function rafHitMove() {
        hitIntrv = requestAnimationFrame(rafHitMove); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            } // Направление зрачков вперед
	        rightPupil.style.transform = 'translate(2px, 2px)'; leftPupil.style.transform = 'translate(2px, 2px)';
	        // Hit position 1 **********************************************************************
	        if (hitPos == 1) { 
	            hba_rot -= rotSpeed * 0.1 * k; head_rot += rotSpeed * 0.1 * k;
	            // Righr arm
	            if (fr_arm_rot > -30) {fr_arm_rot -= rotSpeed * 1.3 * k;} 
	            else if (fr_arm_rot <= -30) {r_arm_rot -= rotSpeed * 1.2 * k;}
	            // Left arm
	            if (fl_arm_rot > -90) {
	            	l_arm_rot += rotSpeed * 0.9 * k; fl_arm_rot -= rotSpeed * 3.9 * k;
	            } else if (fl_arm_rot <= -90) {
	                l_arm_rot -= rotSpeed * 1.25 * k; if (l_arm_rot >= -5) fl_arm_rot -= rotSpeed * 0.7 * k;
	            } // Переход на позицию 2
	            if (r_arm_rot <= -100) {
	                r_arm_rot = -100; cancelAnimationFrame(hitIntrv); hitIntrv = null;
	                hitPos = 2; hitMove();
	                // if (!hitPos2Flag) {
	                //     hitPos2Flag = true; setTimeout(function() {hitPos2Flag = false; hitPos = 2; hitMove();}, 100);
	                // }
	            }
	        } // Hit position 2 *********************************************************************
	        else if (hitPos == 2) { 
	            hba_rot += rotSpeed * 0.4 * k; head_rot -= rotSpeed * 0.1 * k;
	            // Righr arm
	            r_arm_rot += rotSpeed * 1.2 * k;
	            if (fr_arm_rot <= 10) fr_arm_rot += rotSpeed * 1.3 * k;
	            r_palm_rot += rotSpeed * 1 * k; 
	            // Left arm
	            l_arm_rot += rotSpeed * 1.8 * k; 
	            fl_arm_rot += rotSpeed * 2.1 * k;
	            l_palm_rot += rotSpeed * 0.4 * k; 
	            // Достижение удара *********
	            if (r_arm_rot >= -49) { 
	                if (volumeData.soundFlag == 'on') hitSound.play(); 
	                r_arm_rot = -49; fr_arm_rot = 10; r_palm_rot = 42; l_arm_rot = -6; fl_arm_rot = -17; hba_rot = 6.5;
	                // Урон
	                if (locNum == 2) damage = (charData.charAtk + charData.exAtk) * rotSpeed; 
	                else if (locNum == 3) damage = (charData.charAtk + charData.pickAtk) * rotSpeed;
	                // Зелья силы
	                if (numUsePot == 0) damage *= 1.5;
	                else if (numUsePot == 2 || numUsePot == 4) damage *= 2;
	                // Жизни елемента
	                elem.hpElem -= damage; 
	                // Показ урона
	                if (damage > 99) showQuantDam.innerHTML = Math.round(damage); 
	                else showQuantDam.innerHTML = Math.round(damage * 10) / 10; 
	                clearTimeout(timerShowDam); cancelAnimationFrame(showDamIntrvl); showDam.style.display = 'none'; 
	                animShowDamage(); 
	                // Atk Record
	                if (damage > recordData.atkRecNum) {
	                    recordData.atkRecNum = damage; 
	                    if (damage > 99) atkRecShow.innerHTML = Math.round(recordData.atkRecNum);
	                    else atkRecShow.innerHTML = Math.round(recordData.atkRecNum * 10) / 10;
	                    window.localStorage.setItem("dataRecords3", JSON.stringify(recordData));
	                } // Hide notch
	                hidePiece(); if (elem.hpElem <= 0) pieceNum = 0;
	                rotSpeed = 0.5; onesUpSpeed = true; cancelAnimationFrame(hitIntrv); hitIntrv = null; hitIntrv = null;
	                backMove(); shakingElem(); shakeTimer = setTimeout(function() {cancelAnimationFrame(shakeIntrv);}, 600); 
	            } 
	        } // Transform rotate
	        hba.style.transform = 'rotate(' + hba_rot + 'deg)'; head.style.transform = 'rotate(' + head_rot + 'deg)';
	        rightArm.style.transform = 'rotate(' + r_arm_rot + 'deg)'; firRightArm.style.transform = 'rotate(' + fr_arm_rot + 'deg)';
	        rightPalm.style.transform = 'rotate(' + r_palm_rot + 'deg)';
	        leftArm.style.transform = 'rotate(' + l_arm_rot + 'deg)'; firLeftArm.style.transform = 'rotate(' + fl_arm_rot + 'deg)';
	        leftPalm.style.transform = 'rotate(' + l_palm_rot + 'deg)';
	        k = 0;
	    }
    } rafHitMove(); // Запуск функции
}

// Функция урона бензопилы и перфоратора *****************************************************************************************************
function damageSawPerf() {
    let last = performance.now(), dt = 0;
    function rafDamageSawPerf() {
        damTools2Intrv = requestAnimationFrame(rafDamageSawPerf);
        let now = performance.now(); dt += (now - last); last = now;
        if (numUsePot == 1) sawPerfStep = 1000 * 0.75;
	    else if (numUsePot == 3 || numUsePot == 4) sawPerfStep = 1000 * 0.5;
	    else sawPerfStep = 1000;
	    // Нанесение урона
        if (dt > sawPerfStep) { 
            dt -= sawPerfStep; 
            // Damage
            if (locNum == 2) damage = charData.exAtk;
            else if (locNum == 3) damage = charData.pickAtk;
            // Зелья силы
            if (numUsePot == 0) damage *= 1.5;
            else if (numUsePot == 2 || numUsePot == 4) damage *= 2;
            // Жизни элемента
            elem.hpElem -= damage; showQuantDam.innerHTML = Math.round(damage); 
            // Показ урона
            clearTimeout(timerShowDam); cancelAnimationFrame(showDamIntrvl); showDam.style.display = 'none'; animShowDamage();
            // Hide notch
            hidePiece();
            // Dead elem
            if (elem.hpElem <= 0) {
                pieceNum = 0; cancelAnimationFrame(shakeIntrv);;
                cancelAnimationFrame(shakingTools2Intrvl); cancelAnimationFrame(damTools2Intrv); 
                setTimeout(function() {
                	backMoveTools2();
                }, 100);
            }
        }
    } rafDamageSawPerf(); // Запуск функции
}


// Получение опыта, уровня и ресурсов ************************************************************************************************************
function hidePiece() {
    let numRes = 0, numExp = 0, pieceNumNow = 0, numRar;
    // Hide notch
    while (elem.hpElem <= elem.hpPiece[pieceNum]) {
        if (pieceNum <= elem.quantPiece) elem.piece[pieceNum].style.display = 'none'; 
        numExp += elem.expPiece; // Получение опыта
        numRes += elem.resPiece; // Получение ресурсов
        pieceNum += 1; pieceNumNow += 1; 
    } // Show exp elem
    if (numExp > 0) {
        // Показ элемента получаемого опыта
        clearTimeout(timerShowExp); cancelAnimationFrame(showExpIntrvl); showExp.style.display = 'none'; 
        showQuantExp.innerHTML = numExp; animShowExp(); 
        // Увеличение опыта и уровня **************************
        charData.expNum += numExp; 
        if (charData.expNum >= charData.maxExpNum && charData.lvlNum < 51) {
        	if (volumeData.soundFlag == 'on') lvlupSound.play();
            // Показ сообщения об увеличении уровня
            mesLvlUp.style.display = 'block'; mesLvlUp.classList.add('hide-mes');
            setTimeout(function() {mesLvlUp.style.display = 'none'; mesLvlUp.classList.remove('hide-mes');}, 3000);
            // Увеличение уровня 
            charData.lvlNum += 1; lvlMainMA.innerHTML = charData.lvlNum; lvlMenu.innerHTML = charData.lvlNum;
            // Увеличение бороды
            if (charData.lvl_beard >= 0) beardsMainMA[charData.lvl_beard].style.display = 'none';
            if (charData.lvlNum <= 51) {
                charData.lvl_beard = charData.lvlNum - 2; quantBeardMain.innerHTML = charData.lvl_beard + 1;
            } beardsMainMA[charData.lvl_beard].style.display = 'block'; 
            // exp
            charData.expNum -= Math.round(charData.maxExpNum);
            // maxExp 
            charData.maxExpNum *= charData.multExp;
            if (charData.lvlNum < 13) charData.multExp -= 0.03;
            else if (charData.lvlNum < 21) charData.multExp -= 0.025;
            else if (charData.lvlNum < 26) charData.multExp -= 0.02;
            else if (charData.lvlNum < 36) charData.multExp -= 0.01;
            else if (charData.lvlNum < 42) charData.multExp -= 0.005;
            else if (charData.lvlNum <= 51) charData.multExp -= 0.002;
            maxExpMenu.innerHTML = Math.round(charData.maxExpNum);
            // status points
            if (charData.lvlNum % 2 == 0) charData.spPlusNum += 1;
            charData.stPointsNum += charData.spPlusNum; spInfo.innerHTML = charData.stPointsNum;
            // Увеличение стоимости зелий
            potionsPriceSell = potionsPriceSell.map(function(num) {return Math.round(num * (1.25 - charData.lvlNum * 0.0031));});
            window.localStorage.setItem("priceStimsKey3", JSON.stringify(potionsPriceSell));
        } expMenu.innerHTML = charData.expNum; 
        expProgress.style.width = charData.expNum * 42 / charData.maxExpNum + '%'; 
        numExp = 0; // Обнуление numExp
        // Запись в LS
        window.localStorage.setItem("dataCharKey3", JSON.stringify(charData)); 
    } // Show res elem
    if (numRes > 0) {
        clearTimeout(timerShowRes); cancelAnimationFrame(showResIntrvl); showRes.style.display = 'none';
        showWood.style.display = 'none'; showRedWood.style.display = 'none'; 
        showStone.style.display = 'none'; showDiamond.style.display = 'none';
        if (locNum == 2) {
            if (elem.lvlRes == 1) {
                showQuantRes.innerHTML = numRes; animShowRes(showWood); resourceNum[0] += numRes; 
                quantResMainMA[0].innerHTML = resourceNum[0]; quantResMenu[0].innerHTML = resourceNum[0];
            } else if (elem.lvlRes == 2) {
                numRar = Math.round(Math.random() * 100);
                if (numRar <= elem.rarity) {
                    showQuantRes.innerHTML = elem.numRarRes * pieceNumNow; 
                    animShowRes(showRedWood); resourceNum[1] += elem.numRarRes * pieceNumNow; 
                    quantResMainMA[1].innerHTML = resourceNum[1]; quantResMenu[1].innerHTML = resourceNum[1];
                } else {
                    showQuantRes.innerHTML = numRes; animShowRes(showWood); resourceNum[0] += numRes; 
                    quantResMainMA[0].innerHTML = resourceNum[0]; quantResMenu[0].innerHTML = resourceNum[0];
                }
            } else if (elem.lvlRes == 3) {
                showQuantRes.innerHTML = numRes; animShowRes(showRedWood); resourceNum[1] += numRes; 
                quantResMainMA[1].innerHTML = resourceNum[1]; quantResMenu[1].innerHTML = resourceNum[1];
            }
        } else if (locNum == 3) {
            if (elem.lvlRes == 1) { 
                showQuantRes.innerHTML = numRes; animShowRes(showStone); resourceNum[2] += numRes; 
                quantResMainMA[2].innerHTML = resourceNum[2]; quantResMenu[2].innerHTML = resourceNum[2];
            } else if (elem.lvlRes == 2) {
                numRar = Math.round(Math.random() * 100);
                if (numRar <= elem.rarity) {
                    showQuantRes.innerHTML = elem.numRarRes * pieceNumNow; 
                    animShowRes(showDiamond); resourceNum[3] += elem.numRarRes * pieceNumNow; 
                    quantResMainMA[3].innerHTML = resourceNum[3]; quantResMenu[3].innerHTML = resourceNum[3];
                } else {
                    showQuantRes.innerHTML = numRes; animShowRes(showStone); resourceNum[2] += numRes; 
                    quantResMainMA[2].innerHTML = resourceNum[2]; quantResMenu[2].innerHTML = resourceNum[2];
                }
            } else if (elem.lvlRes == 3) { 
                showQuantRes.innerHTML = numRes; animShowRes(showDiamond); resourceNum[3] += numRes; 
                quantResMainMA[3].innerHTML = resourceNum[3]; quantResMenu[3].innerHTML = resourceNum[3];
            }
        } numRes = 0; pieceNumNow = 0; // Обнуление numRes
        // Запись в LS
        window.localStorage.setItem("quantResKey3", JSON.stringify(resourceNum));
    } 
}

// Функция анимации показа урона 
function animShowDamage() {
    let damScale = 1, damOpacity = 1;
    showDam.style.transform = 'scale(' + damScale + ')'; showDam.style.opacity = damOpacity;
    showDam.style.display = 'block'; 
    timerShowDam = setTimeout(function() {
        cancelAnimationFrame(showDamIntrvl); showDam.style.display = 'none'; 
    }, 990);
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;         
    function rafAnimShowDamage() {
        showDamIntrvl = requestAnimationFrame(rafAnimShowDamage); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            }  
	        damScale += 0.01 * k; showDam.style.transform = 'scale(' + damScale + ')';
	        damOpacity -= 0.01 * k; showDam.style.opacity = damOpacity;
	        k = 0;
	    }
    } rafAnimShowDamage();
}
// Функция анимации показа опыта 
function animShowExp() {
    let damScale = 1, damOpacity = 1;
    showExp.style.transform = 'scale(' + damScale + ')'; showExp.style.opacity = damOpacity;
    showExp.style.display = 'block'; 
    timerShowExp = setTimeout(function() {
        cancelAnimationFrame(showExpIntrvl); showExp.style.display = 'none'; 
    }, 1990);
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;         
    function rafAnimShowExp() {
        showExpIntrvl = requestAnimationFrame(rafAnimShowExp); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            } 
	        damScale += 0.005 * k; showExp.style.transform = 'scale(' + damScale + ')';
	        damOpacity -= 0.0075 * k; showExp.style.opacity = damOpacity;
	        k = 0; 
	    }
    } rafAnimShowExp();
}
// Функция анимации показа ресурсов 
function animShowRes(showElem) {
    let damScale = 1, damOpacity = 1;
    showRes.style.transform = 'scale(' + damScale + ')'; showRes.style.opacity = damOpacity;
    showRes.style.display = 'block'; showElem.style.display = 'block';
    timerShowRes = setTimeout(function() {
        cancelAnimationFrame(showResIntrvl); showRes.style.display = 'none';
        showWood.style.display = 'none'; showRedWood.style.display = 'none'; 
        showStone.style.display = 'none'; showDiamond.style.display = 'none';
    }, 1990);
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;         
    function rafAnimShowRes() {
        showResIntrvl = requestAnimationFrame(rafAnimShowRes); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            }
	        damScale += 0.005 * k; showRes.style.transform = 'scale(' + damScale + ')';
	        damOpacity -= 0.0075 * k; showRes.style.opacity = damOpacity;
	        k = 0;
	    }
    } rafAnimShowRes();
}


// Возврат элементов чыра *************************************************************************************************************************
function backMove() { 
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;  
    function rafBackMove() {
        backIntrv = requestAnimationFrame(rafBackMove); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            } // Set rotBackSpeed
	        if (numUsePot == 1 && actName == 'hits') rotBackSpeed = (charData.speedPlus + 0.2) * 1.5;
	        else if ((numUsePot == 3 || numUsePot == 4) && actName == 'hits') rotBackSpeed = (charData.speedPlus + 0.2) * 2;
	        else rotBackSpeed = charData.speedPlus + 0.2;
	        // Hba and head
	        if (hba_rot > 0) {hba_rot -= rotBackSpeed * 0.39 * k;} else {hba_rot = 0;}
	        if (head_rot > 0) {head_rot -= rotBackSpeed * 0.39 * k;} else {head_rot = 0;}
	        // Righr arm
	        if (r_arm_rot < 0) {r_arm_rot += rotBackSpeed * 2.47 * k;} else {r_arm_rot = 0;}
	        if (fr_arm_rot > 0) {fr_arm_rot -= rotBackSpeed * 0.715 * k;} else {fr_arm_rot = 0;} 
	        if (r_palm_rot > 0) {r_palm_rot -= rotBackSpeed * 2.275 * k;} else {r_palm_rot = 0;} 
	        // Left arm
	        if (l_arm_rot < 0) {l_arm_rot += rotBackSpeed * 0.325 * k;} else {l_arm_rot = 0;}
	        if (fl_arm_rot < 0) {fl_arm_rot += rotBackSpeed * 0.91 * k;} else {fl_arm_rot = 0;} 
	        if (l_palm_rot > 0) {l_palm_rot -= rotBackSpeed * 1.04 * k;} else {l_palm_rot = 0;} 
	        // Возвращение элементов на начальную позицию
	        if (r_arm_rot >= 0 && fr_arm_rot >= 0 && fl_arm_rot >= 0) {
	            hba_rot = 0; head_rot = 0; 
	            r_arm_rot = 0; fr_arm_rot = 0; r_palm_rot = 0; 
	            l_arm_rot = 0; fl_arm_rot = 0; l_palm_rot = 0;
	            cancelAnimationFrame(backIntrv); backIntrv = null; cancelAnimationFrame(downRotSpIntrv); faceBackAnim();
	            rightPupil.style.transform = 'translate(0px, 0px)'; leftPupil.style.transform = 'translate(0px, 0px)';
	            hitPos = 1; aspdShow.innerHTML = 0; 
	            if (elem.hpElem > 0) {
	            	onesHitMove = false; onesUpSpeed = false;
	            } else if (elem.hpElem <= 0) deadElem();
	        } // Transform rotate
	        hba.style.transform = 'rotate(' + hba_rot + 'deg)'; head.style.transform = 'rotate(' + head_rot + 'deg)';
	        rightArm.style.transform = 'rotate(' + r_arm_rot + 'deg)'; firRightArm.style.transform = 'rotate(' + fr_arm_rot + 'deg)';
	        rightPalm.style.transform = 'rotate(' + r_palm_rot + 'deg)';
	        leftArm.style.transform = 'rotate(' + l_arm_rot + 'deg)'; firLeftArm.style.transform = 'rotate(' + fl_arm_rot + 'deg)';
	        leftPalm.style.transform = 'rotate(' + l_palm_rot + 'deg)';
	        k = 0;
	        //console.log('backIntrv');
	    }
    } rafBackMove();
}
function backMoveSaw() { 
    if (volumeData.soundFlag == 'on') hit2Sound.pause(); 
    faceBackAnim();
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;  
    function rafBackMoveTools2() {
        backIntrv = requestAnimationFrame(rafBackMoveTools2); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            } // Hba and head
	        if (hba_rot > 0) {hba_rot -= 0.2 * k;} else {hba_rot = 0;}
	        if (head_rot > 0) {head_rot -= 0.2 * k;} else {head_rot = 0;}
	        // Righr arm
	        if (r_arm_rot < -12) {r_arm_rot += 0.5 * k;} else {r_arm_rot = -12;}
	        if (r_palm_rot < 25) {r_palm_rot += 0.2 * k;} else {r_palm_rot = 25;} 
	        // Left arm
	        if (fl_arm_rot < -35) {fl_arm_rot += 1.1 * k;} else {fl_arm_rot = -35;} 
	        // Возвращение элементов на начальную позицию
	        if (r_arm_rot >= -12 && fl_arm_rot >= -35 && r_palm_rot >= 25) {
	            hba_rot = 0; head_rot = 0; 
	            r_arm_rot = -12; fr_arm_rot = 0; r_palm_rot = 25; 
	            l_arm_rot = 22; fl_arm_rot = -35; l_palm_rot = 0;
	            cancelAnimationFrame(backIntrv); 
	            rightPupil.style.transform = 'translate(0px, 0px)'; leftPupil.style.transform = 'translate(0px, 0px)';
	            if (elem.hpElem > 0) {
	            	onesHitMove = false; onesUpSpeed = false;
	            } else if (elem.hpElem <= 0) deadElem(); 
	        } // Transform rotate
	        hba.style.transform = 'rotate(' + hba_rot + 'deg)'; head.style.transform = 'rotate(' + head_rot + 'deg)';
	        rightArm.style.transform = 'rotate(' + r_arm_rot + 'deg)'; firRightArm.style.transform = 'rotate(' + fr_arm_rot + 'deg)';
	        rightPalm.style.transform = 'rotate(' + r_palm_rot + 'deg)';
	        leftArm.style.transform = 'rotate(' + l_arm_rot + 'deg)'; firLeftArm.style.transform = 'rotate(' + fl_arm_rot + 'deg)';
	        leftPalm.style.transform = 'rotate(' + l_palm_rot + 'deg)';
	        k = 0;
	        //console.log('backIntrv');
	    }
    } rafBackMoveTools2();
}
function backMovePerf() {  
    if (volumeData.soundFlag == 'on') hit2Sound.pause(); 
    faceBackAnim();
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;  
    function rafBackMoveTools2() {
        backIntrv = requestAnimationFrame(rafBackMoveTools2); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            } // Hba and head
	        if (hba_rot > 0) {hba_rot -= 0.12 * k;} else {hba_rot = 0;}
	        if (head_rot > 0) {head_rot -= 0.12 * k;} else {head_rot = 0;}
	        // Righr arm
	        if (r_arm_rot > 10) {r_arm_rot -= 0.2 * k;} else {r_arm_rot = 10;}
	        if (fr_arm_rot > -60) {fr_arm_rot -= 0.25 * k;} else {fr_arm_rot = -60;} 
	        if (r_palm_rot > -28) {r_palm_rot -= 0.2 * k;} else {r_palm_rot = -28;} 
	        // Left arm
	        if (fl_arm_rot > -65) {fl_arm_rot -= 1.5 * k;} else {fl_arm_rot = -65;} 
	        // Возвращение элементов на начальную позицию
	        if (r_arm_rot <= 10 && fl_arm_rot <= -65 && r_palm_rot <= -28) {
	            hba_rot = 0; head_rot = 0; 
	            r_arm_rot = 10; fr_arm_rot = -60; r_palm_rot = -28; fl_arm_rot = -65; 
	            cancelAnimationFrame(backIntrv); 
	            rightPupil.style.transform = 'translate(0px, 0px)'; leftPupil.style.transform = 'translate(0px, 0px)';
	            if (elem.hpElem > 0) {
	            	onesHitMove = false; onesUpSpeed = false;
	            } else if (elem.hpElem <= 0) deadElem(); 
	        } // Transform rotate
	        hba.style.transform = 'rotate(' + hba_rot + 'deg)'; head.style.transform = 'rotate(' + head_rot + 'deg)';
	        rightArm.style.transform = 'rotate(' + r_arm_rot + 'deg)'; firRightArm.style.transform = 'rotate(' + fr_arm_rot + 'deg)';
	        rightPalm.style.transform = 'rotate(' + r_palm_rot + 'deg)';
	        leftArm.style.transform = 'rotate(' + l_arm_rot + 'deg)'; firLeftArm.style.transform = 'rotate(' + fl_arm_rot + 'deg)';
	        leftPalm.style.transform = 'rotate(' + l_palm_rot + 'deg)';
	        //console.log('backIntrv');
	        k = 0;
	    }
    } rafBackMoveTools2();
}


// Функции потрясывания инструментов после удара ******************************************************************************************
// Функция тряски бензопилы во время резки 
function shakingSaw() {
    faceAnim(); shakingElem(); // Запуск тряски дерева
    let rotElemDir = 'up', rotElem = 0;
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;  
    function rafShakingSaw() {
        shakingTools2Intrvl = requestAnimationFrame(rafShakingSaw); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            }
	        if (rotElemDir == 'up') {
	            if (r_palm_rot > 19) {
	            	r_palm_rot -= 0.5 * k; fl_arm_rot -= 0.5 * k;
	            } else rotElemDir = 'down';
	        } else if (rotElemDir == 'down') {
	            if (r_palm_rot < 21) {
	            	r_palm_rot += 0.5 * k; fl_arm_rot += 0.5 * k;
	            } else rotElemDir = 'up';
	        } rightPalm.style.transform = 'rotate(' + r_palm_rot + 'deg)';
	        firLeftArm.style.transform = 'rotate(' + fl_arm_rot + 'deg)';
	        k = 0;
	    }
    } rafShakingSaw();
}
// Функция тряски бензопилы во время резки 
function shakingPerf() {
    faceAnim(); shakingElem(); // Запуск тряски дерева
    let rotElemDir = 'up', rotElem = 0;
    let last = performance.now(), now, step = 1000 / 60, dt = 0, k = 0;  
    function rafShakingPerf() {
        shakingTools2Intrvl = requestAnimationFrame(rafShakingPerf); 
        now = performance.now(); dt += (now - last); last = now;
        if (dt >= step) { 
            while (dt >= step) {
                dt -= step; k += 1;
            }
	        if (rotElemDir == 'up') {
	            if (r_palm_rot > -21) {
	            	r_palm_rot -= 0.5 * k; fl_arm_rot -= 0.5 * k;
	            } else rotElemDir = 'down';
	        } else if (rotElemDir == 'down') {
	            if (r_palm_rot < -19) {
	            	r_palm_rot += 0.5 * k; fl_arm_rot += 0.5 * k;
	            } else rotElemDir = 'up';
	        } rightPalm.style.transform = 'rotate(' + r_palm_rot + 'deg)';
	        firLeftArm.style.transform = 'rotate(' + fl_arm_rot + 'deg)';
	        k = 0;
	    }
    } rafShakingPerf();
}


// Функции анимации лица при ударах ********************************************************************************************************************
function faceAnim() {
    mouth1.style.display = 'none'; mouth2.style.display = 'block';
    rightUpEyelid.style.transform = 'translateY(2px)'; leftUpEyelid.style.transform = 'translateY(2px)';
    rightLowEyelid.style.transform = 'translateY(-1px)'; leftLowEyelid.style.transform = 'translateY(-1px)';
}
function faceBackAnim() {
    mouth1.style.display = 'block'; mouth2.style.display = 'none';
    rightUpEyelid.style.transform = 'translateY(0px)'; leftUpEyelid.style.transform = 'translateY(0px)';
    rightLowEyelid.style.transform = 'translateY(0px)'; leftLowEyelid.style.transform = 'translateY(0px)';
}


// Функции выбора инструментов ************************************************************************************************************
function takeExPick() {
    r_arm_rot = 0; fr_arm_rot = 0; r_palm_rot = 0; // Righr arm
    l_arm_rot = 0; fl_arm_rot = 0; l_palm_rot = 0; // Left arm
    rightArm.style.transform = 'rotate(' + r_arm_rot + 'deg)'; firRightArm.style.transform = 'rotate(' + fr_arm_rot + 'deg)';
    rightPalm.style.transform = 'rotate(' + r_palm_rot + 'deg)';
    leftArm.style.transform = 'rotate(' + l_arm_rot + 'deg)'; firLeftArm.style.transform = 'rotate(' + fl_arm_rot + 'deg)';
    leftPalm.style.transform = 'rotate(' + l_palm_rot + 'deg)';
}
function takeSaw() {
    r_arm_rot = -12; fr_arm_rot = 0; r_palm_rot = 25; // Righr arm
    l_arm_rot = 22; fl_arm_rot = -35; l_palm_rot = 0; // Left arm
    rightArm.style.transform = 'rotate(' + r_arm_rot + 'deg)'; firRightArm.style.transform = 'rotate(' + fr_arm_rot + 'deg)';
    rightPalm.style.transform = 'rotate(' + r_palm_rot + 'deg)';
    leftArm.style.transform = 'rotate(' + l_arm_rot + 'deg)'; firLeftArm.style.transform = 'rotate(' + fl_arm_rot + 'deg)';
    leftPalm.style.transform = 'rotate(' + l_palm_rot + 'deg)';
} 
function takePerf() {
    r_arm_rot = 10; fr_arm_rot = -60; r_palm_rot = -28; // Righr arm
    l_arm_rot = 15; fl_arm_rot = -65; l_palm_rot = 0; // Left arm
    rightArm.style.transform = 'rotate(' + r_arm_rot + 'deg)'; firRightArm.style.transform = 'rotate(' + fr_arm_rot + 'deg)';
    rightPalm.style.transform = 'rotate(' + r_palm_rot + 'deg)';
    leftArm.style.transform = 'rotate(' + l_arm_rot + 'deg)'; firLeftArm.style.transform = 'rotate(' + fl_arm_rot + 'deg)';
    leftPalm.style.transform = 'rotate(' + l_palm_rot + 'deg)';
} 



