"use strict";
const optMenu = document.getElementById('game-options'), exitOpt = document.getElementById('exit-options'),
creditsWindow = document.getElementById('credits-window'), langWindOpt = document.getElementById('lang-wind-opt'),
// Звуки
buttonSound = document.getElementById('button-sound'),moneySound = document.getElementById('money-sound'),drinkSound = document.getElementById('drink-sound'),
lvlupSound  = document.getElementById('lvlup-sound');
let hitSound = null, hit2Sound = null,
// Музыка
locMusik = document.getElementById('map-musik');
// Кресты в кнопках звука и музыки
const musicCross = document.getElementById('no-music-elem'),
soundCross = document.getElementById('no-sound-elem');

let volumeData = {
	musicFlag: 'on',
	soundFlag: 'on'
}

// Volume setup 
if (window.localStorage.getItem("volumeKey3") !== null) {
    volumeData = JSON.parse(window.localStorage.getItem("volumeKey3")); 
    if (volumeData.musicFlag == 'on') musicCross.style.display = 'none';
    else musicCross.style.display = 'block';
    if (volumeData.soundFlag == 'on') soundCross.style.display = 'none';
    else soundCross.style.display = 'block';
}


// Функция открытия меню опций *****************************************************************************************************************
const btnOpenOpt = document.getElementById('btn_x5F_options');
btnOpenOpt.addEventListener(clickDownEvent, pushBtns, false); btnOpenOpt.addEventListener(clickMoveEvent, moveBtns, false);
btnOpenOpt.addEventListener(clickUpEvent, openOptionsFunc, false);

function openOptionsFunc() {
	if (!notPushBtnFlag) {
		// Stop game
        stopGame();
        // Открытие опций
		optMenu.style.display = 'block'; menuFlag = true;
	}
}

// Обработчик кнопок меню опций **************************************************************************************************************
optMenu.addEventListener(clickDownEvent, pushBtns, false); 
optMenu.addEventListener(clickMoveEvent, moveBtns, false);
optMenu.addEventListener(clickUpEvent, optionsFunc, false);

function optionsFunc(event) {
	if (!notPushBtnFlag) {
		switch(event.target.id) {
			// Выход из опций
			case 'btn-exit-options':
				if (!notPushBtnFlag) closeOptMenu();
	        break; 	
	        // Переход на страницу сайта privacy policy
	        case 'btn-policy':
	        	window.location.replace("https://barsukstudio.github.io/miner_privacy.html");
        	break;
	        // Выбор игры в разделе more games *******
	        case 'btn-more-game':
	            window.location.replace("https://play.google.com/store/apps/dev?id=6043684000948739501");
	        break; 
	        // Credits window
	        case 'btn-credits-window':
	            creditsWindow.style.display = 'block';
	        break;  
	        // Вкл/выкл звуков и музыки
			case 'btn-music-volume': 
				if (volumeData.musicFlag == 'on') {
					musicCross.style.display = 'block';
					volumeData.musicFlag = 'off'; 
					locMusik.pause();
					locMusik.currentTime = 0;
				} else {
					musicCross.style.display = 'none';
					volumeData.musicFlag = 'on'; 
					locMusik.play();
				} // Set LS volumeKey3
				window.localStorage.setItem("volumeKey3", JSON.stringify(volumeData));
			break;
			case 'btn-sounds-volume': 
				if (volumeData.soundFlag == 'on') {
					soundCross.style.display = 'block';
					volumeData.soundFlag = 'off'; 
				} else {
					soundCross.style.display = 'none';
					volumeData.soundFlag = 'on'; 
					buttonSound.play();
				} // Set LS volumeKey3
				window.localStorage.setItem("volumeKey3", JSON.stringify(volumeData));
			break;
			// Select language
			case 'btn-change-lang-opt':
				langWindOpt.style.display = 'block';
			break;  
		} 
	}
}
function closeOptMenu() {
	if (langWindOpt.style.display == 'block') langWindOpt.style.display = 'none'; 
	if (creditsWindow.style.display == 'block') creditsWindow.style.display = 'none'; 
	else { 
		// Закрытие опций
		optMenu.style.display = 'none'; menuFlag = false;
		// Continue game 
		contGame(); 
		// Show tutorial
		if (!finishTutorialFlag) { 
			mesTutorialMA.style.display = 'block'; mesMainMA.style.display = 'block';  mesTutorial[numTutorial].style.display = 'block';
		}
	}
}

// Обработчики кнопок в окне сброса выбора языка ********************************************************************************************
langWindOpt.addEventListener(clickDownEvent, pushBtns);
langWindOpt.addEventListener(clickMoveEvent, moveBtns);
langWindOpt.addEventListener(clickUpEvent, changeLangFunc);

function changeLangFunc(event) {
	if (!notPushBtnFlag) {
		switch(event.target.id) {	
			case 'btn-lang-eng-opt': selectLang(0); break; 
	        case 'btn-lang-rus-opt': selectLang(1); break; 
	        case 'btn-lang-por-opt': selectLang(2); break; 
		}
	}
}




